c   Cross-Validation Granger Causality Test --  Basic Tests Version
c
c     May 4, 2016
c
c  Same as Nov 27, 2012 code, but re-compiling with Intel fortran compiler revealed some
c  minor bugs.
c
c  version oct 11c fixes bugs in the way the simulated data for both numpower >0 and numpower <0 
c  is created.
c
c  version oct_11a fixes bug in the way power data generated for ipowrestrict=4 to include 
c  lagged dependent variable in the generating model.
c
c  (Sept 27th code adds 5-period postsample test and option to datamine on samples generated
c   with all or some coefficients time-varying according to an AR(1) process.  Oct 5th code 
c   ads option ipowrestrict=3, which generates the data without a lagged dependent variable so 
c   as to re-examine the size of the wild bootstrap in that case.)
c  (oct 5 code identical except it failed to print out the right code date into the output.)
c  (adds to oct 6th code the input variable ilagdep, allowing generated data to use the original
c   data (ilagdep=1) or else use bootstrap to choose starting values (ilagdep=0), as formerly.)
c
c same as oct 12th, but fixes failure to print out power for 5% quantile.
c
c  Sets up power calculations using data generated for each power simulation from the true,
c  causative model, implemented via ipowrestrict=4.
c  
c  Also makes fractile grid denser so that 75% fractile power is calculated. This was fixed for
c  numpower>0 output in Oct 17th code and additionally fixed for numpower<0 output in Oct 18th 
c  code.
c
c  oct26a version is the same as Oct 18th, but adds crossvalidation test based on the sample mean of the 
c f_tau statistics to the tests based on sample fractiles of these numtau statistics.
c
c
c  Nov 3d version is the same as oct26a, but adds last read-in paramter: lengthwind.  If numpower=0 
c  and lengthwind is less than n, this computes the test p-values for a set of moving windows and saves them
c  to crossgranger_window_pvalues.csv.  Nov 10th  version "a" is the same, but now also saves the p-values for 
c  the tests on the individual F_tau's.   Nov 10th version inputs weightmean parameter right after seed in
c  input file and computes weighted mean of the F-tau's. Nov 11th version replaces "%" symbol in windowing write
c  to csv file and also now accepts input of lengthwindow > n as signal to stop gracefully after using the
c  entire sample just once.    Nov 21st version adds ipowerestrict =5 for dropping the two zero coefficients 
c  in getting power for the T=20 case.
c
c
c
      parameter(mxlaglim=40,mw=4000,maxsim=10000)
c
c  mw         = max # sample observations
c  mxlaglim   = max # regressors in regression model, including intercept
c
      real*8 ystart(-100:mw),xstart(mw,mxlaglim),ypow(-100:mw),
     1         xpow(mw,mxlaglim),ymine(-100:mw),xmine(mw,mxlaglim),
     1         ywind(-100:mw),xwind(mw,mxlaglim)
c
      real beta(mxlaglim),betahat(mxlaglim),fstat_sample(-31:mw),
     1       pee_value_reject(-31:mw),power(-31:mw),
     1  betasampleunrestrict(mxlaglim),tsampleunrestrict(mxlaglim),
     1  epssampleunrestrict(mw),betatemp(mxlaglim),ttemp(mxlaglim),
     1  epstemp(mw),weights4mean(mw),
     1  beta4pow(mxlaglim),t4pow(mxlaglim),eps4pow(mw),
     1  betadev(0:mw,mxlaglim),pwindow(-31:mw,mw)
c
      integer ipowcount(-31:mw),istrt(mw),iend(mw)
      character*8 varlabel(0:mxlaglim) ,dummyread
      character*14 testlabel(0:32)
c
c
c   Note regarding arrays (fstat_sample,pee_value_reject, power, and ipowcount):
c                                                  over [itaumin,itaumax)
c     index -31 refers to new test,  mean of new test statistic    
c
c     index -30 refers to McCracken MSE_F test with  5 postsample periods
c
c     index -29 refers to new test, minimum value of new test statistic 
c                                                  over [itaumin,itaumax)
c     index -28 refers to new test,  5% quantile of new test statistic 
c                                                  over [itaumin,itaumax)    
c     index -27 refers to new test, 10% quantile of new test statistic 
c                                                  over [itaumin,itaumax) 
c     index -26 refers to new test, 15% quantile of new test statistic 
c                                                  over [itaumin,itaumax) 
c     index -25 refers to new test, 20% quantile of new test statistic 
c                           
c     index -24 refers to new test, 25% quantile of new test statistic 
c                                                  over [itaumin,itaumax) 
c     index -23 refers to new test, 30% quantile of new test statistic 
c                                                  over [itaumin,itaumax) 
c     index -22 refers to new test, 35% quantile of new test statistic 
c                                                  over [itaumin,itaumax) 
c     index -21 refers to new test, 40% quantile of new test statistic 
c                                                  over [itaumin,itaumax) 
c     index -20 refers to new test, 45% quantile of new test statistic 
c                                                  over [itaumin,itaumax)    
c     index -19 refers to new test, 50% quantile of new test statistic 
c                                                  over [itaumin,itaumax) 
c     index -18 refers to new test, 55% quantile of new test statistic 
c                                                  over [itaumin,itaumax) 
c     index -17 refers to new test, 60% quantile of new test statistic 
c
c     index -16 refers to new test, 65% quantile of new test statistic 
c                                                  over [itaumin,itaumax) 
c     index -15 refers to new test, 70% quantile of new test statistic 
c                                                  over [itaumin,itaumax) 
c     index -14 refers to new test, 75% quantile of new test statistic 
c                                                  over [itaumin,itaumax) 
c     index -13 refers to new test, 80% quantile of new test statistic 
c                                                  over [itaumin,itaumax) 
c     index -12 refers to new test, 85% quantile of new test statistic 
c                                                  over [itaumin,itaumax)    
c     index -11 refers to new test, 90% quantile of new test statistic 
c                                                  over [itaumin,itaumax) 
c     index -10 refers to new test, 95% quantile of new test statistic 
c                                                  over [itaumin,itaumax) 
c     index -9  refers to new test, maximum value of new test statistic 
c                                                  over [itaumin,itaumax)                
c     index -8 refers to McCracken MSE_F test with 100 postsample periods
c     index -7 refers to McCracken MSE_F test with  40 postsample periods
c     index -6 refers to McCracken MSE_F test with  20 postsample periods
c     index -5 refers to McCracken MSE_F test with  10 postsample periods
c     index -4 refers to usual F test (theory using F distribution)
c     index -3 refers to usual F test (statistic is bootstrapped here)
c     index -2 refers to new test, median  value of new test statistic 
c                                                  over [itaumin,itaumax)
c     index -1 refers to new test, 90% quantile of new test statistic 
c                                                  over [itaumin,itaumax)
c     index  0 refers to new test, maximum value of new test statistic 
c                                                  over [itaumin,itaumax)
c     index  itau in [itaumin,itaumax] refers to new test statistic with sample
c                  split at period itau 
c
c  for time/date stamping routine:
c
      integer values(8)
      CHARACTER*10 date,time,zone
c
c   for routine (gasdev) that generates unit normals 
c
      common /gassav/ gset,iset
c
c
c   for routine that generates random integers for use in bootstrapping:
c
      COMMON /RANSET/FIMM,IMM,IAA,ICC,IDUM,IY,IDECK(97)
c
C
c   open output file
c
      open(6,file='crossgranger.out')
c
c
c
c  write version and date/time
c
      month =  5
      nday =  4
      nyr = 2016
      write(6,'(''Version '',i2,''-'',i2,''-'',i4)') month,nday,nyr
      call date_and_time(date,time,zone,values)
      write(6,'(''Run Started at: (HHMM:SS:hh) '',a4,'':'',a5)')
     1 time(1:4),time(5:9)
      write(6,'(''Current Date: (MM/DD/YYYY) '',a2,''/'',a2,''/'',a4)')
     1 date(5:6),date(7:8),date(1:4)
      write(6,'(/)')
c
c
c
      open(4,file='crossgranger.inp')
      read(4,'(i5)') n
      write(6,'(''sample length                         = '',i5)') n
      open(4,file='crossgranger.inp')
c
      go to 666
      read(4,'(i5)') numskip
      write(6,'(''number of input obs to skip on read   = '',i5)') 
     1                                         numskip
  666 continue
      numskip = 0
      read(4,'(i5)') numvarreadin
      write(6,'(''number of explanatory variables       = '',i5)') 
     1                       numvarreadin
      read(4,'(i5)') numlag
      write(6,'(''number of lagged dependent variables  = '',i5)') 
     1                       numlag
      read(4,'(i5)') numcause  
      write(6,'(''number of putative causing variables  = '',i5)') 
     1                       numcause 
      read(4,'(i5)') numsim
      write(6,'(''number of simulations used            = '',i5)') 
     1                       numsim
      fnumsim = float(numsim)
      read(4,'(i5)') numsimestprint
      write(6,'(''number of simulations printed         = '',i5)') 
     1                       numsimestprint
      read(4,'(i5)') iechodata
      write(6,'(''number of sample data printed         = '',i5)') 
     1                      iechodata
c
      read(4,'(i5)') iwild
      if (iwild .eq. 0 .or. iwild .eq. 1) then
          write(6,'(''wild (1) vs ordinary (0) bootstrap    = '',i5)') 
     1                      iwild
      else
          write(6,'(''wild (1) vs ordinary (0) bootstrap    = '',i5)') 
     1                      iwild
          stop
      endif
c
      read(4,'(i5)') min_ndf
      write(6,'(''minimum number of dfs in either model = '',i5)') 
     1                      min_ndf
c
      read(4,'(i5)') idum
      if (idum .lt. 1)  then
          write(6,'(''random number generator seed, '',i5,
     1     '' must be positive integer'')') idum
          stop
      else
          write(6,'(''seed for unit normal generator        = '',i5)') 
     1                      idum
      endif
c
c
      weightmean = 1.
      causeparm = .4
      idatamine = 1
      nsample = 0
      iread = 1
      igendata = 0
      ipeeprint = 1
      ipowrestrict = 0
      ixbootedalso  = 0
      rhoforbeta  = .3
      numpower = 0
c
c
      go to 998
      
      
      read(4,fmt=*) weightmean
      write(6,'(''middle-to-end ratio in weighted mean   = '', f10.5
     1  )')      weightmean
c
      if (weightmean .lt. 1.) then
               write(6,'(//''parameter weightmean = '',f10.5,
     1            '' should not be less than one.'')') weightmean
          stop
      endif
c
c
      read(4,fmt=*) causeparm
c
c
      read(4,'(i5)') idatamine
      if (idatamine .ge. 1) then
          write(6,'(''number of models examined for each ''/,
     1           5x,   ''power simulation                 = '',i5)') 
     1                      idatamine
      else
          write(6,'(''parameter idatamine = '',i5,
     1            '' must exceed zero.'')') idatamine
          stop
      endif
c
c
      read(4,'(i5)') nsample
      if (nsample .eq. 0) then
          nsample = n
          write(6,'(''nsample read in as 0 and reset to n ='',i5)') 
     1                      nsample
      else
          write(6,'(''nsample             = '',i5,
     1       '' (Used for data mining if idatamine>1 and numpower<0.)''
     1        )') nsample
      endif
c
c
      read(4,'(i5)') iread
      if (iread .eq. 0 .or. iread .eq. 1) then
         if (iread .eq. 0 ) then
          write(6,'( ''data read from file '',
     1          ''crossgranger_gendata.csv (iread = 0)'')') 
         else
          write(6,'( ''data read from file '',
     1          ''crossgranger_data.csv (iread = 1)'')')   
         endif
      else
           write(6,'(''parameter iread = '',i5,
     1            '' must equal zero or one.'')') iread
          stop
      endif
c
c
      read(4,'(i5)') igendata
      write(6,'(''parameter igendata                    = '',i5)') 
     1    igendata
      if (igendata .eq. 0 .or. igendata .eq. 1) then
          if (igendata .eq. 0 ) then
              write(6,'(5x,''--> data is not generated and written to''/,
     1           8x,'' crossgranger_gendata.csv'')') 
          else
              write(6,'(5x,''--> data is generated and written to''/,
     1         8x,'' crossgranger_gendata.csv program then stops''
     1                   )')  
          endif 
      else
          write(6,'(''parameter igendata must be either 0 or 1   = '',
     1           i5)')  igendata
          stop
      endif
c
c
      read(4,'(i5)') ipeeprint
      write(6,'(''parameter ipeeprint                   = '',i5)') 
     1    ipeeprint
      if (ipeeprint .eq. 0 .or. ipeeprint .eq. 1 
     1                     .or. ipeeprint .eq. 2) then
          if (ipeeprint .eq. 1 ) 
     1         write(6,'(5x,
     1         ''--> p-value & power printed for each split'')') 
          if (ipeeprint .eq. 0 ) 
     1         write(6,'(5x,
     1         ''--> p-value & power not printed for each split'')') 
          if (ipeeprint .eq. 2 ) 
     1         write(6,'(5x,
     1         ''--> p-value for each split printed to file '',
     1              ''crossgranger_pvalues.csv'')') 
      else
          write(6,'(
     1     ''parameter ipeeprint must be either 0 or 1 or 2   = '',
     1           i5)')  ipeeprint
          stop
      endif
c
c
      read(4,'(i5)') ipowrestrict
      write(6,'(''parameter ipowrestrict                = '',i5)') 
     1    ipowrestrict
      if (ipowrestrict .eq. 0 .or. ipowrestrict .eq. 1
     1                 .or. ipowrestrict .eq. 2
     1                 .or. ipowrestrict .eq. 3
     1                 .or. ipowrestrict .eq. 4
     1                 .or. ipowrestrict .eq. 5
     1                  ) then
          if (ipowrestrict .eq. 1 ) then
               write(6,'(5x,
     1         ''--> power simulations use data generated from '',
     1         ''the estimated restricted model '')')
               write(6,'(5x,
     1         ''--> WARNING: this is not the default setting''
     1                  )')
          endif
          if (ipowrestrict .eq. 2 ) then
               write(6,'(5x,
     1         ''--> power simulations use data generated from '',
     1         ''the restricted posited model: ''/
     1     12x,''beta(1) = .2  (on lagged dependent variable)''/
     1     12x,''beta(2) = .2  (on constant)''/
     1     12x,''beta(3) = .3  (on 1st exogenous variable)''/
     1     12x,''beta(4) = .3  (on 2nd exogenous variable)'')')
               write(6,'(5x,
     1         ''--> WARNING: this is not the default setting but is''/
     1      15x,''   appropriate in size calculations for the paper.''
     1                  )')
          endif  
          if (ipowrestrict .eq. 3 ) then
               write(6,'(5x,
     1         ''--> power simulations use data generated from '',
     1         ''the restricted posited model: ''/
     1     12x,''beta(1) = 0.  (on lagged dependent variable)''/
     1     12x,''beta(2) = .2  (on constant)''/
     1     12x,''beta(3) = .3  (on 1st exogenous variable)''/
     1     12x,''beta(4) = .3  (on 2nd exogenous variable)'')')
               write(6,'(5x,
     1         ''--> WARNING: this is not the default setting but is''/
     1      15x,''   appropriate in size calculations for the paper'' /
     1      15x,''   when lagged dependent variable omitted.''
     1                  )')
             if (numlag .ne. 0)   then
                 write(6,'(
     1          ''parameter numlag must be 0 when ipowrestrict = 3'')')
                 stop
             endif
          endif  
          if (ipowrestrict .eq. 4 ) then
               write(6,'(5x,
     1         ''--> power simulations use data generated from '',
     1         ''the unrestricted posited model: ''/
     1     12x,''beta(1) = .2  (on lagged dependent variable)''/
     1     12x,''beta(2) = .2  (on constant)''/
     1     12x,''beta(3) = .3  (on 1st exogenous variable)''/
     1     12x,''beta(4) = .3  (on 2nd exogenous variable)''/
     1     12x,''beta(5) = .0  (on 3d  exogenous variable)''/   
     1     12x,''beta(6) = .4  (on 1st causative variable)''/
     1     12x,''beta(7) = .0  (on 2nd causative variable)''/
     1  )')
               write(6,'(5x,
     1        ''--> WARNING: this is not the default setting but is''/
     1    15x,''   appropriate in power calculations for the paper,''/
     1    15x,''   (use generated data set y(1) = -1.07525498)''/
     1    15x,''   Use numlag=1, causeparm=.4 ilagdep=1''/
     1    15x,''   numvarreadin = 6 numcause = 2 .''/ 
     1    15x,''   numpower = 1000 or 10000 for ordinary power.''/   
     1    15x,''   numpower = -1000 or -10000 and ''/
     1    15x,''   idatamine=25 and nsample = 25, 50, or 100 with''/
     1    15x,''   ixbootedalso=0 rhoforbeta=.3 for AR1 data mining.''  
     1                )')
          endif  
          if (ipowrestrict .eq. 5 ) then
               write(6,'(5x,
     1         ''--> power simulations use data generated from '',
     1         ''the unrestricted posited model: ''/
     1     12x,''beta(1) = .2  (on lagged dependent variable)''/
     1     12x,''beta(2) = .2  (on constant)''/
     1     12x,''beta(3) = .3  (on 1st exogenous variable)''/
     1     12x,''beta(4) = .3  (on 2nd exogenous variable)''/
     1     12x,''beta(6) = .4  (on 1st causative variable)''/
     1  )')
               write(6,'(5x,
     1        ''--> WARNING: this is not the default setting but is''/
     1    15x,
     1 ''   appropriate in T=20 power calculations for the paper,''/
     1    15x,''   (use simpler generated data set''/
     1    15x,''   Use numlag=1, causeparm=.4 ilagdep=1''/
     1    15x,''   numvarreadin =4 numcause =1 .''/ 
     1    15x,''   numpower = 1000 or 10000 for ordinary power.''/   
     1    15x,''   numpower = -1000 or -10000 and ''/
     1    15x,''   idatamine=25 and nsample = 25, 50, or 100 with''/
     1    15x,''   ixbootedalso=0 rhoforbeta=.3 for AR1 data mining.''  
     1                )')
          endif  
          if (ipowrestrict .eq. 0 ) 
     1         write(6,'(5x,
     1         ''--> power simulations use data generated from '',
     1    ''the estimated unrestricted model (the default setting)'')') 
        else
          write(6,'(
     1 ''parameter ipowrestrict must be either 0, 1, 2, 3, 4 or 5 '',
     1     ''but instead = '', i5)')  ipowrestrict
          stop
      endif
c
c
      read(4,'(i5)')ixbootedalso 
      write(6,'(''parameter ixbootedalso                = '',i5)') 
     1    ixbootedalso
          if (ixbootedalso .eq. 0 ) then
              write(6,'(5x,
     1            ''--> x data fixed for the idatamine simulations''/
     1     5x,''    done for each power simulation if numpower < 0'')') 
          else
               write(6,'(5x,''--> x data bootstrapped for sample '',
     1        ''period in the idatamine simulations''/
     1    5x,''    done for each power simulation if numpower < 0'')') 
          write(6,'(5x,
     1      ''--> WARNING: this setting makes sense only if '',
     1    ''the x data are known to ''/
     1              5x,''            be iid, as in simulated data.'')') 
                             
          endif 
c
c
      read(4,fmt=*) rhoforbeta
      write(6,'(''coef. on AR(1) for beta if numpower < 0 ='', f10.5
     1  )')      rhoforbeta
      if (abs(rhoforbeta) .ge. .0001) then
        varar1innovfact = (1. - (rhoforbeta**2)) /4.
        write(6,'(/5x,''(If numpower<0, then power simulations '',
     1  ''generate data using AR(1) variations ''/
     1  5x,''around the unrestricted''
     1  '' OLS estimates with this AR(1) coefficient and the''/
     1  5x,''innovation variance ='', f8.5,
     1  '' times the square of each beta estimate.)''//)') 
     1  varar1innovfact
        varar1innovfact = 0.
      endif
      if (abs(rhoforbeta) .ge. 1.) then
         write(6,'(/'' magnitude of coef. on AR(1) must be < 1.'')')  
         stop 
      endif
c
c
      read(4,'(i6)') numpower
c
      do kk = 1,27
        read(4,'(a8)') dummyread
      enddo
c
  998 continue
      read(4,'(i5)') ilagdep
      write(6,'(''parameter ilagdep                     = '',i5)') 
     1    ilagdep 
      if (ilagdep  .eq. 0 .or. ilagdep  .eq. 1) then
          if (ilagdep .eq. 1 ) then
             write(6,'(5x,''--> Starting data used for lagged depe'',
     1         ''ndent variables in generated samples.''/)')
          else
            write(6,'(5x,''--> Bootstrap used generating lagged depe'',
     1         ''ndent variables in generated samples.''/)') 
          endif 
      else
          write(6,'(''parameter ilagdep must be either 0 or 1. '')')   
          stop
      endif
c
c
c      close (4)
c
c
      go to 888
      if (numpower .eq. 0)
     1 write(6,'(''number of power calc simulations        = '',i6/
     1  5x,''(equals zero for simply computing rejection p-values ''
     1  /5x,
     1  '' from data to be read in from file specified above)  ''
     1  //)')       numpower
c
      if (numpower .gt. 0 )  then
         write(6,'(''number of power calc simulations      = '',i6/
     1    5x,
     1  ''{Using data generated from estimated unrestricted model '',
     1     ''(if ipowrestrict = 0)''/
     1    /5x,
     1    '' or from estimated restricted model (if ipowrestrict = 1)''/
     1    /5x,
     1    '' or from restricted "true" model (if ipowrestrict = 2)''/
     1   5x,'' (Use this for size calcs based on this model.}''/  
     1    /5x,
     1    '' or from restricted "true" model omitting lagged ''/
     1    5x,'' dependent variable (if ipowrestrict = 3)''/
     1   5x,'' (Use this for size calcs based on that model.}''/
     1    /5x,
     1    '' or from unrestricted "true" model (if ipowrestrict = 4)''/
     1    5x, '' (Use this for power calcs based on this model.''/
     1    /5x,  
     1    '' or from unrestricted "true" model (if ipowrestrict = 5)''/
     1   5x,
     1   '' (Use this for power calcs based on this model'',
     1       '' when T = 20.''
     1    //)')       numpower
      endif
c
c
      if (numpower .gt. 0 .and. idatamine .ne. 1)  then
         write(6,'(''Warning: parameter idatamine should be set '',
     1        ''to one when numpower is positive.'')')   
         stop
      endif
c
c
c
      if (numpower .lt. 0) then
        write(6,'(''minus number of power simulations     = '',i5/
     1  5x,''The power calculations use data generated from the'',
     1  '' model with highest adjusted''/,
     1  5x,''R-square out of '',i3,'' data sets generated/estimated''/,
     1  5x,''from the data read in from file specified above.  '' /
     1  5x,''(Estimation is over first nsample ='',i5,
     1  '' observations.)''/
     1  5x,''(AR(1) coefficient for stochastic parameter variation ='',
     1  f6.2,'')''//)')       -numpower ,idatamine,nsample,rhoforbeta
c        if (ipowrestrict .ne. 0 .and. ipowrestrict .ne. 4) then
             write(6,'(
     1        ''ipowrestrict must be zero or '',
     1         ''four or five if numpower is negative'')')
c           stop
c        endif
c 
      if (idatamine .lt. 2) then
           write(6,'(
     1      ''WARNING: idatamine should exceed one if numpower'',
     1             '' is negative so that some data mining occurs.'')')
            stop
       endif
      endif
c
  888 continue
c
      if (n .gt. mw) then
         write(6,'(
     1    '' need to increase dimension parameter mw'')')
         stop
      endif
c
c
      if (numlag .lt. 0) then
         write(6,'(
     1    '' A negative value of numlag was read in.'')')
         stop
      endif
c
c
      if (n*numlag .ge. 3000) then
         write(6,'( //''WARNING!''/
     1    ''The random number generator (irand) used here to '',
     1    ''to pick random integers in [1, n] for use in ''/
     2    ''bootstrapping the lagged dependent variable(s) is'',
     1    '' not suitable for values of n*numlag much''/
     1    '' larger than 3000.''//)')
      endif
c
c
C  PLACE THE DEFINING PARAMETERS FOR THE RANDOM NUMBER GENERATOR
C  USED IN BOOTSTRAPPING INTO LABELLED COMMON HERE:
C
C
      IMM = 714025
      FIMM = FLOAT(IMM)
      IAA = 1366
      ICC = 150889

C  NOW INITIALIZE THE RANDOM NUMBER GENERATOR BY FILLING UP THE
C  IDECK ARRAY :
C
           IDUM = MOD(ICC-IDUM,IMM)
           IDUM = MOD(IAA*IDUM+ICC,IMM)
           DO 111 J = 1,97
           IDUM = MOD(IAA*IDUM+ICC,IMM)
  111      IDECK(J) = IDUM
           IDUM = MOD(IAA*IDUM+ICC,IMM)
           IY = IDUM
c
c
c    Initialize unif uniform random number generator
c    by calling it with idum < 0.
c    (this routine is used by the routine (gasdev) that generates
c    unit normals)
c    unif will set up shuffling array and return idum = 0 so subsequent
c    calls will pick from that.
c
c     idum = -1502
c     idum = -9502
c
c  idum is now read in from input file and made negative (right here)
c  for first call to unif
c
      idum = - idum
      q = unif(idum)
      q = q+1
c
c   initialize routine that generates gaussians (gasdev)
c
      gset = 0.
      q = gasdev(idum)
c
      if (iread .eq. 0 .and. numlag .ne. 1) then
          write(6,'(//''NOTE: Data in file crossgranger_gendata.csv '',
     1     ''were generated  with numlag equal to one.''//)')
          stop
      endif
c
c  set number of regressors in model, k:
c
      k =numvarreadin  + numlag
      if (k .ge. mxlaglim) then
         write(6,'(
     1  '' need to increase dimension parameter mxlaglim'')')
         stop
      endif
c
c
      itaumin =   min_ndf  + k
      itaumax =  n - k  - min_ndf
      numtau = itaumax - itaumin + 1
c
      write(6,'(''   -->  tau is in interval ['',i5,'' , '',i5,''] ''
     1                       )')itaumin,itaumax
c
      write(6,'(''   -->  number of sample splits is '',i5)')numtau
      if (numtau .lt. 1) stop
c
c calculate weights4mean array and print it out
c
      weights4mean(itaumin) = 1.
      numtaueven =   numtau - (2*(numtau/2) )
      if (numtaueven .eq. 0) then
           write(6,'(10x,'' (number of splits is even)'')')
      else
           write(6,'(10x,'' (number of splits is odd)'')')
      endif
c
      if (numtau .eq. 1)  weights4mean(itaumin) = 1. 
      if (numtau .eq. 2 ) then 
         weights4mean(itaumin)   = 1.
         weights4mean(itaumin+1) = 1.    
      endif
      if (numtau .eq. 3 ) then 
         weights4mean(itaumin)   = 1.
         weights4mean(itaumin+1) = weightmean  
         weights4mean(itaumin+2) = 1.    
      endif
      if (numtau .eq. 4 ) then 
         weights4mean(itaumin)   = 1.
         weights4mean(itaumin+1) = weightmean  
         weights4mean(itaumin+2) = weightmean  
         weights4mean(itaumin+3) = 1.    
      endif
c
c
      if (numtau .gt. 4 .and. numtaueven .eq. 0) then
c         (here numtau is even and at least 6)
        numincrements = (numtau/2) -1
        wincrement = (weightmean - 1.)/float(numincrements)
        do it = 1, numtau/2
           itt = it + itaumin -1
           weights4mean(itt) 
     1          = 1. + wincrement*float(it-1)
        enddo
        weights4mean((numtau/2) + itaumin) =  
     1              weights4mean((numtau/2) + itaumin - 1)
        do it = (numtau/2) + 2 , numtau
          itt = it + itaumin -1
          weights4mean(itt) 
     1          = weights4mean(itt-1)  - wincrement
        enddo
      endif
c
c
      if (numtau .gt. 3 .and. numtaueven .eq. 1) then
c         (here numtau is odd and at least 5)
        numincrements = (numtau/2) 
        wincrement = (weightmean - 1.)/float(numincrements)
        do it = 1, (numtau/2) + 1
           itt = it + itaumin -1
          weights4mean(itt) 
     1          = 1. + wincrement*float(it-1)
        enddo
c     
        do it = (numtau/2) + 2 , numtau
          itt = it + itaumin -1
          weights4mean(itt) 
     1          = weights4mean(itt-1)  - wincrement
        enddo
      endif
      go to 777
      write(6,'(/''  Relative Weights used in Weighted Mean'')')
      write(6,'( '' (Will be normalized so as to sum to one.)'')')
      write(6,'(8x,''    tau     weight''/)')
      do itau = itaumin, itaumax
         write(6,'(10x,i4,4x,f8.4)') itau,weights4mean(itau)
      enddo
  777 continue
c
c
      waitsum = 0.
      do itau = itaumin, itaumax
        waitsum = waitsum + weights4mean(itau)
      enddo
      do itau = itaumin, itaumax
        weights4mean(itau) = weights4mean(itau)/waitsum
      enddo
c
c
c
      if (igendata .eq. 1 ) then
c
c    generate and save sample data, then stop
c    
c
c
c   The first numlag values of the lagged dependent variable 
c   are obtained by re-sampling at random from the y vector; the rest via 
c   the dynamic simulations.
c
c   generate dependent and explanatory variable data 
c       (first variate is for single lagged dependent variable, 
c       second is for the intercept in this example)
c
      beta(1) = .2
      beta(2) = .2
      beta(3) = .3
      beta(4) = .3
      beta(5) = 0.
      beta(6) = causeparm
      beta(7) = 0.
      if (k .ge. 8) then
        do ik = 8,k
           beta(ik) = 0.
           varlabel(ik) = '  var   ' 
        enddo
      endif
      ystart(0) = dble(gasdev(idum))
c
      do in = 1, n
        ystart(in) = dble(beta(1))*ystart(in-1) +  dble(beta(2))
        xstart(in,1) = ystart(in-1)
        xstart(in,2) = 1.d0
        do ik = 3,k
          xstart(in,ik) =  dble(gasdev(idum))
          ystart(in) = ystart(in) + dble(beta(ik))* xstart(in,ik)
        enddo
        ystart(in) = ystart(in) + dble(gasdev(idum))
      enddo
c
       do i = 8,mxlaglim
           varlabel(i) = '        '
       enddo 
       varlabel(0) = 'depvar  '
       varlabel(1) = 'lagd_dep'
       varlabel(2) = 'constant'
       varlabel(3) = '   X1   '
       varlabel(4) = '   X2   '
       varlabel(5) = '   X3   ' 
       varlabel(6) = ' cawz1  '
       varlabel(7) = ' cawz2  '
c
c
c   writes the generated data out to csv file and then stops:
c 

       open(3,file='crossgranger_gendata.csv')
       write (3,'(100(a8,'' , ''))') (varlabel(jj),jj= 0,k)
       do it = 1, n
         write (3,'(100(f20.8,'' , ''))')
     1      ystart(it),(xstart(it,jj), jj=1,k)
       enddo
       close (3)
c
      stop
c
c   end if block on igendata 
c 
      endif
c
c   open file for reading data to use:
c
      if (iread .eq. 0) open(3,file='crossgranger_gendata.csv') 
      if (iread .eq. 1) open(3,file='crossgranger_data.csv') 
c
         read (3,fmt=*) (varlabel(jj),jj= 0,k)
c
c
c    skip the first numskip observations
c
         if (numskip .gt. 0) then
            do it = 1, numskip
              read (3,fmt=*) 
            enddo
         endif
c
c   read in the sample data that is actually to be used
c
c
         do it = 1, n
            read (3,fmt=*)ystart(it),(xstart(it,jj), jj=1,k)
         enddo
        close (3)
c
c
c      write(6,'(''finished data read  from csv file'')')
c      write(6,'(''iechodata ='',i4)')iechodata
c      stop
c
c
      if (iechodata .gt. 0 .and. iechodata .le. mw) then
       write(6,'(//''First '',i6,'' sample observations on dependent'',
     1   '' and explanatory variables used:'')') iechodata
       do i = 1,iechodata
          write(6,'(i2,2x,100e12.5)')i,ystart(i),(xstart(i,j), j=1,k)
       enddo 
      endif
c
c
c       estimate OLS model for the data read in and print results
c
c
c     call olsreg(ystart,xstart,beta_inputdata,eps_inputdata,t,n,k,
c    1    sse,vcv,ssqd) 
c       ndf = n - k
c       do ik = 1,k
c          tcoef = t(ik)
c          pval(ik)=  tsig(tcoef,ndf)
c       enddo
c
c       ymean = 0.
c       do i = 1,n
c           ymean = ymean + real(ystart(i))
c       enddo
c       ymean = ymean/float(n)
c       vary = 0.
c       do i = 1,n
c           vary = vary +(real(ystart(i)) - ymean)**2
c       enddo
c       vary = vary/float(n-1)
c       rsqrdadj = 1. - (ssqd/vary)
c
c
        write(6,'(///''Using data read in (after skipping '',i5,
     1 '' observations:'')') numskip
c       write(6,'(/a8,x,
c    1  ''  coef      t ratio   sig. level'')')  varlabel(0)
c        do ik = 1,k
c         write(6,'(a8,x,F7.4,3x,f9.3,f11.3)') varlabel(ik),
c    1                 beta_inputdata(ik),t(ik),pval(ik)
c        enddo
c
c     
c      write (6, '(/''s-squared      = '',e20.8)')ssqd
c      write (6, '(''adj. R-squared = '',f20.4/)')rsqrdadj
c
c
c 
c      write(6,'(''got to call gtests stmt'')')
c      stop
      ipow = 0
c
      call gtests(pee_value_reject,pee_usual_F_theory,fstat_sample,
     1    ystart,xstart,beta,n,iechodata,ilagdep,weights4mean,
     1    numvarreadin,numlag,numcause,numsim,fnumsim,numsimestprint,
     1    min_ndf,k,ndf,itaumin,itaumax,numtau,betahat,
     1    varlabel,fstat_usual_sample,numpower,ipow,iwild,nsample)
c
c
c
c
      write (6,'(//''Using '',i5,'' simulations, '',
     1 ''all generated using''/
     1 ''the (restricted) OLS model for the sample data:''/)')
     1   numsim
c
c
c     if (ipeeprint .eq. 1 ) then
         write (6,'(
     1      ''     tau        F statistic    P-value  '')') 
         do itau = itaumin, itaumax
           write(6,'(3x,i5,4x,f15.8,f10.4)')itau,fstat_sample(itau),
     1          pee_value_reject(itau)
         enddo
         write (6,'(/)')
c     endif
c
c 
      if (ipeeprint .eq. 2 ) then
         open(13,file='crossgranger_pvalues.csv')      
         write (13,'(''tau,F statistic,P-value  '')') 
         do itau = itaumin, itaumax
           write(13,'(i5,'','',f15.8,'','',f10.4)')itau,
     1            fstat_sample(itau),pee_value_reject(itau)
         enddo
         close (13)
      endif
c
c
      write(6,'(15x,''   statistic    P-value'')')
      write(6,'(''     min    '',f15.8,f10.4)')
     1     fstat_sample(-29),pee_value_reject(-29)
      write(6,'(''      5%    '',f15.8,f10.4)')
     1     fstat_sample(-28),pee_value_reject(-28)
      write(6,'(''     10%    '',f15.8,f10.4)')
     1     fstat_sample(-27),pee_value_reject(-27)
      write(6,'(''     15%    '',f15.8,f10.4)')
     1     fstat_sample(-26),pee_value_reject(-26)
      write(6,'(''     20%    '',f15.8,f10.4)')
     1     fstat_sample(-25),pee_value_reject(-25)
      write(6,'(''     25%    '',f15.8,f10.4)')
     1     fstat_sample(-24),pee_value_reject(-24)
      write(6,'(''     30%    '',f15.8,f10.4)')
     1     fstat_sample(-23),pee_value_reject(-23)
      write(6,'(''     35%    '',f15.8,f10.4)')
     1     fstat_sample(-22),pee_value_reject(-22)
      write(6,'(''     40%    '',f15.8,f10.4)')
     1     fstat_sample(-21),pee_value_reject(-21)
      write(6,'(''     45%    '',f15.8,f10.4)')
     1     fstat_sample(-20),pee_value_reject(-20)
      write(6,'(''   median   '',f15.8,f10.4)')
     1     fstat_sample(-19),pee_value_reject(-19)
      write(6,'(''     55%    '',f15.8,f10.4)')
     1     fstat_sample(-18),pee_value_reject(-18)
      write(6,'(''     60%    '',f15.8,f10.4)')
     1     fstat_sample(-17),pee_value_reject(-17)
      write(6,'(''     65%    '',f15.8,f10.4)')
     1     fstat_sample(-16),pee_value_reject(-16)
      write(6,'(''     70%    '',f15.8,f10.4)')
     1     fstat_sample(-15),pee_value_reject(-15)
      write(6,'(''     75%    '',f15.8,f10.4)')
     1     fstat_sample(-14),pee_value_reject(-14)
      write(6,'(''     80%    '',f15.8,f10.4)')
     1     fstat_sample(-13),pee_value_reject(-13)
      write(6,'(''     85%    '',f15.8,f10.4)')
     1     fstat_sample(-12),pee_value_reject(-12)
      write(6,'(''     90%    '',f15.8,f10.4)')
     1     fstat_sample(-11),pee_value_reject(-11)
      write(6,'(''     95%    '',f15.8,f10.4)')
     1     fstat_sample(-10),pee_value_reject(-10)
      write(6,'( ''     max    '',f15.8,f10.4)')
     1     fstat_sample( -9),pee_value_reject( -9)
      write(6,'(/''    mean    '',f15.8,f10.4)')
     1     fstat_sample(-31),pee_value_reject(-31)
      write(6,'(/''usual F test'',f15.8,f10.4,
     1   ''    (using F dist theory: '',f10.4,'')'')')
     1     fstat_usual_sample,pee_value_reject(-3),
     1       pee_value_reject(-4)
      write(6,'(  /
     1  ''                                               '',
     1  ''statistic    P-value'')')
      write(6,'( ''McCracken MSE-F (  5 postsample periods) ='',
     1          f15.8,f10.4)') fstat_sample(-30),pee_value_reject(-30)
      write(6,'( ''McCracken MSE-F ( 10 postsample periods) ='',
     1          f15.8,f10.4)') fstat_sample(-5),pee_value_reject(-5)
      write(6,'( ''McCracken MSE-F ( 20 postsample periods) ='',
     1          f15.8,f10.4)') fstat_sample(-6),pee_value_reject(-6)
      write(6,'( ''McCracken MSE-F ( 40 postsample periods) ='',
     1          f15.8,f10.4)') fstat_sample(-7),pee_value_reject(-7)
      write(6,'( ''McCracken MSE-F (100 postsample periods) ='',
     1          f15.8,f10.4)') fstat_sample(-8),pee_value_reject(-8)
c
c
c     write(6,'(  / )')
c     do ii = itaumin, itaumax
c        write(6,'( ''Using test statistic for tau ='',i2,
c    1   '' periods ='',
c    1     f15.8,f10.4)') ii,fstat_sample(ii),pee_value_reject(ii)
c     enddo
c
c
c
c ***********************************************************************
c                                                                       *
c       if block for numpower = 0                                       *
c                                                                       *
c************************************************************************
c
c
      if (numpower .eq. 0) then
        numtauorig = numtau
        norig = n
        if (numtauorig .gt. 1) then
c
        read(4,'(i5)') lengthwindow
        write(6,'(///''parameter lengthwindow                = '',i5)') 
     1       lengthwindow
        if (lengthwindow .lt. 1 ) then
             write(6,'(5x,
     1       ''--> lengthwindow set too small''/)')
             stop
        endif
c
        if (lengthwindow .gt. n ) then
             write(6,'(5x,
     1       ''--> lengthwindow exceeds sample length,''/
     1   5x, ''    so no windowing is done, nor csv file''/
     1   5x, ''    created.''/)')
         stop
        endif
c
        close (4)
c
        numwindow = 0
        numwindows = 0
        iwindstart = 0
 5324   iwindstart = iwindstart + 1
        iwindend   = iwindstart -1 + lengthwindow
        if (iwindend .le. norig) then
           numwindow = numwindow + 1
           numwindows = numwindows + 1
c
           istrt(numwindow) = iwindstart
           iend(numwindow) =  iwindend 
           do it = iwindstart,iwindend
             ywind(it - iwindstart + 1) = ystart(it)
             do jj = 1,k
               xwind(it - iwindstart + 1,jj) = xstart(it,jj)
             enddo
           enddo 
c     
           n = lengthwindow
           ndf = n - k
c
           if (numwindow .eq. 1) then
              itaumin =   min_ndf  + k
              itaumax =  n - k  - min_ndf
              numtau = itaumax - itaumin + 1
c
              write(6,'(
     1 ''   -->  tau is in interval ['',i5,'' , '',i5,''] ''
     1     ,''for each window''          )')itaumin,itaumax
c
              write(6,'(''   -->  number of sample splits is '',i5,
     1         '' for each window'')')numtau
              if (numtau .lt. 1) stop
           endif
c  
c
c
c
        write(6,'(///''Using data for window number '',i5,
     1 '' observations  ('',i5,'','',i5,''):'')') numwindow,
     1    iwindstart,iwindend
c       write(6,'(/a8,x,
c    1  ''  coef      t ratio   sig. level'')')  varlabel(0)
c        do ik = 1,k
c         write(6,'(a8,x,F7.4,3x,f9.3,f11.3)') varlabel(ik),
c    1                 beta_inputdata(ik),t(ik),pval(ik)
c        enddo
c
c     
c      write (6, '(/''s-squared      = '',e20.8)')ssqd
c      write (6, '(''adj. R-squared = '',f20.4/)')rsqrdadj
c
c
c
      ipow = 0
c
      call gtests(pee_value_reject,pee_usual_F_theory,fstat_sample,
     1    ywind,xwind,beta,n,iechodata,ilagdep,weights4mean,
     1    numvarreadin,numlag,numcause,numsim,fnumsim,numsimestprint,
     1    min_ndf,k,ndf,itaumin,itaumax,numtau,betahat,
     1    varlabel,fstat_usual_sample,numpower,ipow,iwild,nsample)
c
c
c
c
      write (6,'(//''Using '',i5,'' simulations, '',
     1 ''all generated using''/
     1 ''the (restricted) OLS model for the sample data:''/)')
     1   numsim
c
c
         write (6,'(
     1      ''     tau        F statistic    P-value  '')') 
         do itau = itaumin, itaumax
           write(6,'(3x,i5,4x,f15.8,f10.4)')itau,fstat_sample(itau),
     1          pee_value_reject(itau)
         enddo
         write (6,'(/)')
c
      write(6,'(15x,''   statistic    P-value'')')
      write(6,'(''     min    '',f15.8,f10.4)')
     1     fstat_sample(-29),pee_value_reject(-29)
      write(6,'(''      5%    '',f15.8,f10.4)')
     1     fstat_sample(-28),pee_value_reject(-28)
      write(6,'(''     10%    '',f15.8,f10.4)')
     1     fstat_sample(-27),pee_value_reject(-27)
      write(6,'(''     15%    '',f15.8,f10.4)')
     1     fstat_sample(-26),pee_value_reject(-26)
      write(6,'(''     20%    '',f15.8,f10.4)')
     1     fstat_sample(-25),pee_value_reject(-25)
      write(6,'(''     25%    '',f15.8,f10.4)')
     1     fstat_sample(-24),pee_value_reject(-24)
      write(6,'(''     30%    '',f15.8,f10.4)')
     1     fstat_sample(-23),pee_value_reject(-23)
      write(6,'(''     35%    '',f15.8,f10.4)')
     1     fstat_sample(-22),pee_value_reject(-22)
      write(6,'(''     40%    '',f15.8,f10.4)')
     1     fstat_sample(-21),pee_value_reject(-21)
      write(6,'(''     45%    '',f15.8,f10.4)')
     1     fstat_sample(-20),pee_value_reject(-20)
      write(6,'(''   median   '',f15.8,f10.4)')
     1     fstat_sample(-19),pee_value_reject(-19)
      write(6,'(''     55%    '',f15.8,f10.4)')
     1     fstat_sample(-18),pee_value_reject(-18)
      write(6,'(''     60%    '',f15.8,f10.4)')
     1     fstat_sample(-17),pee_value_reject(-17)
      write(6,'(''     65%    '',f15.8,f10.4)')
     1     fstat_sample(-16),pee_value_reject(-16)
      write(6,'(''     70%    '',f15.8,f10.4)')
     1     fstat_sample(-15),pee_value_reject(-15)
      write(6,'(''     75%    '',f15.8,f10.4)')
     1     fstat_sample(-14),pee_value_reject(-14)
      write(6,'(''     80%    '',f15.8,f10.4)')
     1     fstat_sample(-13),pee_value_reject(-13)
      write(6,'(''     85%    '',f15.8,f10.4)')
     1     fstat_sample(-12),pee_value_reject(-12)
      write(6,'(''     90%    '',f15.8,f10.4)')
     1     fstat_sample(-11),pee_value_reject(-11)
      write(6,'(''     95%    '',f15.8,f10.4)')
     1     fstat_sample(-10),pee_value_reject(-10)
      write(6,'( ''     max    '',f15.8,f10.4)')
     1     fstat_sample( -9),pee_value_reject( -9)
      write(6,'(/''    mean    '',f15.8,f10.4)')
     1     fstat_sample(-31),pee_value_reject(-31)
      write(6,'(/''usual F test'',f15.8,f10.4,
     1   ''    (using F dist theory: '',f10.4,'')'')')
     1     fstat_usual_sample,pee_value_reject(-3),
     1       pee_value_reject(-4)
      write(6,'(  /
     1  ''                                               '',
     1  ''statistic    P-value'')')
      write(6,'( ''McCracken MSE-F (  5 postsample periods) ='',
     1          f15.8,f10.4)') fstat_sample(-30),pee_value_reject(-30)
      write(6,'( ''McCracken MSE-F ( 10 postsample periods) ='',
     1          f15.8,f10.4)') fstat_sample(-5),pee_value_reject(-5)
      write(6,'( ''McCracken MSE-F ( 20 postsample periods) ='',
     1          f15.8,f10.4)') fstat_sample(-6),pee_value_reject(-6)
      write(6,'( ''McCracken MSE-F ( 40 postsample periods) ='',
     1          f15.8,f10.4)') fstat_sample(-7),pee_value_reject(-7)
      write(6,'( ''McCracken MSE-F (100 postsample periods) ='',
     1          f15.8,f10.4)') fstat_sample(-8),pee_value_reject(-8)
c
c
c     write(6,'(  / )')
c     do ii = itaumin, itaumax
c        write(6,'( ''Using test statistic for tau equals '',i3,
c    1   ''periods ='',
c    1       f15.8,f10.4)') ii,fstat_sample(-ii),pee_value_reject(ii)
c     enddo
c
c
      do itest = -31, -3
         pwindow(itest,numwindow) =  pee_value_reject(itest)
      enddo
      do itau = itaumin, itaumax
          pwindow(itau,numwindow) = pee_value_reject(itau)
      enddo
c
      write(*,'('' Finished working on window  #'',i5)')numwindow
        
c  (else clause for if-block on iwindend <= norig)  
        else 
          write(6,'(/''Tests were done on '',i4,'' windows of '',
     1     ''length '',i4,''.'')')
     1      numwindows,lengthwindow
c
      go to 99
c        
c    (ends if-block on iwindend <= norig)
c
        endif 
c
c
       go to 5324
c
c    (ends if-block on numtauorig>1
c
        endif
c
c
   99 continue
c
c  here write pwindow array to disk
c
      testlabel(  0)  = '  window num  '
      testlabel(  1)  = '  start obs.  '      
      testlabel(  2)  = '   end obs.   '      
      testlabel(  3)  = '   minimum    '
      testlabel(  4)  = 'quantile 5    '
      testlabel(  5)  = 'quantile 10   '
      testlabel(  6)  = 'quantile 15   '
      testlabel(  7)  = 'quantile 20   '
      testlabel(  8)  = 'quantile 25   '
      testlabel(  9)  = 'quantile 30   '
      testlabel( 10)  = 'quantile 35   '
      testlabel( 11)  = 'quantile 40   '
      testlabel( 12)  = 'quantile 45   '
      testlabel( 13)  = '    median    '
      testlabel( 14)  = 'quantile 55   '
      testlabel( 15)  = 'quantile 60   '
      testlabel( 16)  = 'quantile 65   '
      testlabel( 17)  = 'quantile 70   '
      testlabel( 18)  = 'quantile 75   '
      testlabel( 19)  = 'quantile 80   '
      testlabel( 20)  = 'quantile 85   '
      testlabel( 21)  = 'quantile 90   '
      testlabel( 22)  = 'quantile 95   '
      testlabel( 23)  = '   maximum    '
      testlabel( 24)  = '    mean      '
      testlabel( 25)  = 'usual F boot  '
      testlabel( 26)  = 'usual F theory'
      testlabel( 27)  = '  MSE-F 5     '
      testlabel( 28)  = '  MSE-F 10    '
      testlabel( 29)  = '  MSE-F 20    '
      testlabel( 30)  = '  MSE-F 40    '
      testlabel( 31)  = '  MSE-F 100   '
      testlabel( 32)  = '    tau equals'
      open(12,file='crossgranger_window_pvalues.csv')
      write (12,'(32(a14,'' , ''),132(a14,i4,'' , '')    )') 
     1            (testlabel(jj),jj= 0,31),
     1            (testlabel(32),jj,jj=itaumin,itaumax)
      do iwindow = 1, numwindows
         write (12,'(i5,'','',i5,'','',i5,'','',129(f20.8,'' , ''))')
     1      iwindow, istrt(iwindow),iend(iwindow),
     1      (pwindow(itest,iwindow), itest=-29,-9),
     1       pwindow( -31 ,iwindow),
     1       pwindow(  -3 ,iwindow),
     1       pwindow(  -4 ,iwindow),
     1       pwindow( -30 ,iwindow),
     1       pwindow(  -5 ,iwindow),
     1       pwindow(  -6 ,iwindow),
     1       pwindow(  -7 ,iwindow),
     1       pwindow(  -8 ,iwindow),
     1      (pwindow(itest,iwindow), itest=itaumin,itaumax)
      enddo     
c   
      close (12)
c
c    (ends if-block on numpower = 0)
      endif
c
c initialize power counters
c
      do ii = -31, itaumax
        ipowcount(ii) = 0
      enddo
c
c ***********************************************************************
c                                                                       *
c       if block for numpower > 0                                       *
c                                                                       *
c************************************************************************
      if (numpower .gt. 0) then
c
c     estimate restricted or unrestricted model for the sample data read in,
c     depending on value of ipowrestrict:
c
        if (ipowrestrict .eq. 1) then
          do ik = 1,k
             beta4pow(ik) = 0.
             beta(ik) = 0.
          enddo
          krestrict = k - numcause
          call olsreg(ystart,xstart,beta4pow,
     1      eps4pow,t4pow,n,krestrict,sse,vcv,ssqd)
        endif
        if (ipowrestrict .eq. 0) then
          call olsreg(ystart,xstart,beta4pow,
     1      eps4pow,t4pow,n,k,sse,vcv,ssqd)
        endif
c
        if (ipowrestrict .eq. 2) then
          do ik = 1,k
             beta4pow(ik) = 0.
          enddo
          beta4pow(1) = .2
          beta4pow(2) = .2
          beta4pow(3) = .3
          beta4pow(4) = .3
          do it = 1,n
            eps4pow (it) = gasdev(idum)
          enddo
        endif
c
        if (ipowrestrict .eq. 3) then
          do ik = 1,k
             beta4pow(ik) = 0.
          enddo
          beta4pow(1) = 0.
          beta4pow(2) = .2
          beta4pow(3) = .3
          beta4pow(4) = .3
          do it = 1,n
            eps4pow (it) = gasdev(idum)
          enddo
        endif
c
        if (ipowrestrict .eq. 4) then
          do ik = 1,k
             beta4pow(ik) = 0.
          enddo
          beta4pow(1) = .2
          beta4pow(2) = .2
          beta4pow(3) = .3
          beta4pow(4) = .3
          beta4pow(6) = .4
          do it = 1,n
            eps4pow (it) = gasdev(idum)
          enddo
        endif
c
        if (ipowrestrict .eq. 5) then
          do ik = 1,k
             beta4pow(ik) = 0.
          enddo
          beta4pow(1) = .2
          beta4pow(2) = .2
          beta4pow(3) = .3
          beta4pow(4) = .3
          beta4pow(5) = .4
          do it = 1,n
            eps4pow (it) = gasdev(idum)
          enddo
        endif
c
c fill explanatory variable array for all of the columns,
c even the numcause variables not in the restricted model,
c so that later on it is possible to simulate data from
c the unrestricted model at need.
c 
c
      if (ilagdep .eq. 1) then 
         do irow = 1,n
         do icol = 1,k 
            xpow(irow,icol) =  xstart(irow,icol)
         enddo
         enddo
      else
         do irow = 1,n
         do icol = numlag+1,k 
            xpow(irow,icol) =  xstart(irow,icol)
         enddo
         enddo      
      endif
c
c
      write(6,'(//''P-values for first ten power simulations:''/)')
      do ipow = 1,numpower
c
      write(*,'('' working on power simulation #'',i5,'' out of '',i5
     1    )')ipow,numpower
c
c   
c   The simulations must account for the dynamics (and randomly bootstrapped 
c   start-up values) if there are lagged dependent variables -- these are 
c   assumed to be in columns 1 through numlag of the X matrix; the other 
c   explanatory variables, including a column of ones if there is an intercept
c   in the model, are treated as "fixed in repeated samples" 

c        
c   Note that the wild bootstrap is implemented by multiplying epsrestrict(it) 
c   by an niid(0,1) variate produced by gasdev(idum).
c
      if (numlag .gt. 0) then
        if (ilagdep .eq. 0) then 
          do ilag = 1-numlag, 0
            iii =  IRANDD(n)
            ypow(ilag) = ystart(iii)
          enddo
        else
          do ilag = 1-numlag, 0
            iii = 1 + ilag
            ypow(ilag)  = xpow(1, iii)
          enddo
        endif
        do it = 1, n
             do ilag = 1, numlag
               xpow(it,ilag) = ypow(it - ilag)
             enddo       
          ypow(it) = 0.d0         
c 
          do ik = 1, k 
            ypow(it) = ypow(it) 
     1         + dble(beta4pow(ik))*xpow(it,ik)
          enddo
          if (iwild .eq. 1) then
             ee = eps4pow(it)*gasdev(idum)
          else
             iii =  IRANDD(n)
             ee = eps4pow(iii)
          endif
c         ypow(it) = ypow(it) + dble(gasdev(idum))
          ypow(it) = ypow(it) + dble(ee)
        enddo
      else
        do it = 1, n
          ypow(it) = 0.d0
          do ik = 1, k 
            ypow(it) = ypow(it) 
     1        + dble(beta4pow(ik))*xpow(it,ik)
          enddo
         if (iwild .eq. 1) then
             ee = eps4pow(it)*gasdev(idum)
          else
             iii =  IRANDD(n)
             ee = eps4pow(iii)
          endif
c         ypow(it) = ypow(it) + dble(gasdev(idum))
          ypow(it) = ypow(it) + dble(ee)
        enddo  
      endif
c  
c
      call gtests(pee_value_reject,pee_usual_F_theory,fstat_sample,
     1    ypow,xpow,betarestrict,n,iechodata,ilagdep,weights4mean,
     1    numvarreadin,numlag,numcause,numsim,fnumsim,numsimestprint,
     1    min_ndf,k,ndf,itaumin,itaumax,numtau,betahat,
     1    varlabel,fstat_usual_sample,numpower,ipow,iwild,nsample)
c
c 
      if (ipow .eq. 1) write(6,'(  4x,
     1'' F (thy)  F (boot) McC 10   McC 20   McC 40   McC100   '',
     1 ''median     90%    maximum  taumin   taumax'')') 
      if (ipow .le. 10) 
     1write(6,'(i2,11f9.4)')ipow, pee_value_reject(-4),
     1 pee_value_reject(-3),
     1 pee_value_reject(-5),
     1 pee_value_reject(-6),
     1 pee_value_reject(-7),
     1 pee_value_reject(-8),
     1   pee_value_reject(-19),pee_value_reject(-11),     
     1   pee_value_reject(-9),pee_value_reject(itaumin),
     1   pee_value_reject(itaumax)
c
      do ii = -31,0
        if (pee_value_reject(ii) .le. .05)  
     1                           ipowcount(ii) = ipowcount(ii)  + 1
      enddo
c
      do ii = itaumin, itaumax
        if (pee_value_reject(ii) .le. .05)  
     1                           ipowcount(ii) = ipowcount(ii)  + 1
      enddo
c
c   end do loop on power simulations (ipow)
c 
     
      enddo
c
c
      fnumpower = float(numpower)
      do ii = -31,0
        power(ii) =   float(ipowcount(ii)) / fnumpower
      enddo
      write(6, '(/''Power for usual F test'',
     1            '' ( theory )                      ='',f10.4)') 
     1                                                    power(-4)
      write(6, '( ''Power for usual F test'',
     1            '' (bootstrap)                     ='',f10.4)') 
     1                                                    power(-3)
      write(6, '( ''Power for McCracken MS''
     1           ,''E-F test(  5 postsample periods) ='',f10.4)') 
     1                                                   power(-30)
      write(6, '( ''Power for McCracken MS''
     1           ,''E-F test( 10 postsample periods) ='',f10.4)') 
     1                                                    power(-5)
      write(6, '( ''Power for McCracken MS''
     1           ,''E-F test( 20 postsample periods) ='',f10.4)') 
     1                                                    power(-6)
      write(6, '( ''Power for McCracken MS''
     1           ,''E-F test( 40 postsample periods) ='',f10.4)') 
     1                                                    power(-7)
      write(6, '( ''Power for McCracken MS''
     1           ,''E-F test(100 postsample periods) ='',f10.4)') 
     1                                                    power(-8)
      write(6, '( ''Power for   minimum ove''
     1            ,''r splits                        ='',f10.4)')
     1                                                    power(-29)
      write(6, '( ''Power for    5% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-28)
      write(6, '( ''Power for   10% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-27)
      write(6, '( ''Power for   15% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-26)
      write(6, '( ''Power for   20% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-25)
      write(6, '( ''Power for   25% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-24)
      write(6, '( ''Power for   30% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-23)
      write(6, '( ''Power for   35% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-22)
      write(6, '( ''Power for   40% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-21)
      write(6, '( ''Power for   45% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-20)
      write(6, '( ''Power for      median ''
     1           ,''split                            ='',f10.4)') 
     1                                                    power(-19)
      write(6, '( ''Power for   55% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-18)
      write(6, '( ''Power for   60% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-17)
      write(6, '( ''Power for   65% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-16)
      write(6, '( ''Power for   70% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-15)
      write(6, '( ''Power for   75% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-14)
      write(6, '( ''Power for   80% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-13)
      write(6, '( ''Power for   85% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-12)
      write(6, '( ''Power for   90% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-11)
      write(6, '( ''Power for   95% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-10)
      write(6, '( ''Power for   maximum ove''
     1            ,''r splits                        ='',f10.4)')
     1                                                    power( -9)
      write(6, '( ''Power for   mean    ove''
     1            ,''r splits                        ='',f10.4)')
     1                                                    power(-31)
      do ii = itaumin, itaumax
        power(ii) = float(ipowcount(ii))  / fnumpower
        write(6,'(''Power for split at ''i5,30x,'' ='',f10.4)') ii,
     1                                                    power(ii) 
      enddo
c
c
c end if-block on numpower > 0
c
      endif
c
c
c
c ***********************************************************************
c                                                                       *
c                 if block for numpower < 0                             *
c                                                                       *
c        (the same except for generation of ypow & xpow,                *
c    which now are based on data-mined model if idatamine > 1)          *
c                                 *                                     *
c                                                                       *
c************************************************************************
c
c
      if (numpower .lt. 0) then
      numpower = abs(numpower)
c
c
      if (ipowrestrict .eq. 0) then
c
c estimate unrestricted model for the sample data read in:
c
         call olsreg(ystart,xstart,betasampleunrestrict,
     1     epssampleunrestrict,tsampleunrestrict,n,k,sse,vcv,ssqd)
      endif
c
c
c
        if (ipowrestrict .eq. 4) then
          do ik = 1,k
             betasampleunrestrict(ik) = 0.
          enddo
          betasampleunrestrict(1) = .2
          betasampleunrestrict(2) = .2
          betasampleunrestrict(3) = .3
          betasampleunrestrict(4) = .3
          betasampleunrestrict(6) = .4
          do it = 1,n
            epssampleunrestrict(it) = gasdev(idum)
          enddo
        endif
c
        if (ipowrestrict .eq. 5) then
          do ik = 1,k
             betasampleunrestrict(ik) = 0.
          enddo
          betasampleunrestrict(1) = .2
          betasampleunrestrict(2) = .2
          betasampleunrestrict(3) = .3
          betasampleunrestrict(4) = .3
          betasampleunrestrict(5) = .4
          do it = 1,n
            epssampleunrestrict(it) = gasdev(idum)
          enddo
        endif
c
c
        if (ipowrestrict .eq. 2) then
          do ik = 1,k
             betasampleunrestrict(ik) = 0.
          enddo
          betasampleunrestrict(1) = .2
          betasampleunrestrict(2) = .2
          betasampleunrestrict(3) = .3
          betasampleunrestrict(4) = .3
          do it = 1,n
            epssampleunrestrict(it) = gasdev(idum)
          enddo
        endif
c
c fill explanatory variable array for all of the columns,
c even the numcause variables not in the restricted model,
c so that later on it is possible to simulate data from
c the unrestricted model at need.
c 
c
      if (ilagdep .eq. 1) then 
         do irow = 1,n
         do icol = 1,k 
            xpow(irow,icol) =  xstart(irow,icol)
         enddo
         enddo
      else
         do irow = 1,n
         do icol = numlag+1,k 
            xpow(irow,icol) =  xstart(irow,icol)
         enddo
         enddo      
      endif
c
c
      write(6,'(//''P-values for first ten power simulations:''/)')
      do ipow = 1,numpower
c
      write(*,'('' working on power simulation #'',i5,'' out of '',i5
     1    )')ipow,numpower
c
c
c here generate ymine and first numlag columns of xmine from the unrestricted 
c OLS model for the sample data read in, call gtests, and increment ipowcount 
c elements for p-values .le. .05
c
c
c ***********  
c   But here -- since numpower was negative entering this if-block --
c   simulate the model estimated over (ystart, xstart) idatamine times, 
c   estimate the model over each of these idatamine simulated data sets,
c   and set (ypow,xpow) to the one with the smallest value of s-squared 
c   (i.e., to the one with the highest adjusted R-squared value)
c **********
c 
c  
      ess2mine = 1.e20
      do imine = 1, idatamine
c
c   The simulations must account for the dynamics (and randomly bootstrapped 
c   start-up values) if there are lagged dependent variables -- these are 
c   assumed to be in columns 1 through numlag of the X matrix; the other 
c   explanatory variables, including a column of ones if there is an intercept
c   in the model, are treated as "fixed in repeated samples" 

c        
c   Note that the wild bootstrap is implemented by multiplying epsrestrict(it) 
c   by an niid(0,1) variate produced by gasdev(idum).
c
c
      if (ixbootedalso .eq. 1) then
        do irow = 1,n
          if (irow .le. nsample) then
             do icol = numlag+1,k 
               iii = irandd(n)
               xmine(irow,icol) =  xstart(iii,icol)
             enddo
          else
            do icol = numlag+1,k 
               xmine(irow,icol) =  xstart(irow,icol)
            enddo
          endif
        enddo
      else
        do irow = 1,n
        do icol = numlag+1,k 
           xmine(irow,icol) =  xstart(irow,icol)
        enddo
        enddo
      endif
c
      if (numlag .gt. 0) then
        do irow = 1,n
        do icol = 1, numlag 
           xmine(irow,icol) =  xstart(irow,icol)
        enddo
        enddo
      endif
c
      if (abs(rhoforbeta) .ge. .0001) then
          do ik = 1, k
            betadev(0,ik) = 0.
            do it = 1,n
               betadev(it,ik) = rhoforbeta*betadev(it-1,ik)
     1                  + sqrt(varar1innovfact)*gasdev(idum)
            enddo
          enddo 
      else
          do ik = 1, k
          do it = 1,n
             betadev(it,ik) = 0.
          enddo
          enddo 
      endif
c
c
      if (numlag .gt. 0) then
        if (ilagdep .eq. 0) then  
           do ilag = 1-numlag, 0   
             iii =  IRANDD(n)
             ymine (ilag) = ystart(iii)
           enddo
        else
          do ilag = 1-numlag, 0
            iii = 1 + ilag
            ymine(ilag)  = xstart(1, iii)
          enddo
        endif
c
        do it = 1, n
              do ilag = 1, numlag
                xmine(it,ilag) = ymine(it - ilag)
              enddo      
          ymine(it) = 0.d0
          do ik = 1, k 
            ymine(it) = ymine(it) 
     1         + dble(betasampleunrestrict(ik) + betadev(it,ik))
     1                              *xmine(it,ik)
          enddo
          if (iwild .eq. 1) then
             ee = epssampleunrestrict(it)*gasdev(idum)
          else
             iii =  IRANDD(n)
             ee = epssampleunrestrict(iii)
          endif
c         ymine(it) = ymine(it) + dble(gasdev(idum))
          ymine(it) = ymine(it) + dble(ee)
        enddo
      else
        do it = 1, n
          ymine(it) = 0.d0
          do ik = 1, k 
            ymine(it) = ymine(it) 
     1        + dble(betasampleunrestrict(ik) + betadev(it,ik))
     1                  *xmine(it,ik)
          enddo
         if (iwild .eq. 1) then
             ee = epssampleunrestrict(it)*gasdev(idum)
          else
             iii =  IRANDD(n)
             ee = epssampleunrestrict(iii)
          endif
c         ymine(it) = ymine(it) + dble(gasdev(idum))
          ymine(it) = ymine(it) + dble(ee)
        enddo  
      endif
c  
c  estimate unrestricted model for ymine 
c
      call olsreg(ymine,xmine,betatemp,
     1   epstemp,ttemp,nsample,k,sse,vcv,ssqd)
c
c
c    if s-squared (ssqd) less than ess2mine -- so that this is the lowest value 
c    of ssqd so far, then 
c    copy first nsample rows of ymine and xmine over to ypow and xpow 
c    Then use coefficients and  fitting errors from the unrestricted
c    regression on (ystart,xstart)to fill out the rest of (ypow,xpow), using these 
c    new values of ypow(nsample-1) ... ypow(nsample-numlag) for startups, as needed:  
c
      if (ssqd .lt. ess2mine)  then
         ess2mine = ssqd
         do it = 1, nsample
              do ik = 1,k
                xpow(it,ik) = xmine(it,ik)
              enddo
              ypow(it)= ymine(it)
         enddo
         if (nsample .lt. n) then
             do it = nsample+1, n
                do ik = 1,k
                  xpow(it,ik) = xmine(it,ik)
                enddo
                if (numlag .gt. 0) then
                  do ilag = 1, numlag
                     xpow(it,ilag) = ypow(it - ilag)
                  enddo 
                endif  
                ypow(it) = 0.d0
                do ik = 1, k 
                  ypow(it) = ypow(it) 
     1              + dble(betasampleunrestrict(ik) + betadev(it,ik))
     1                      *xpow(it,ik)
                enddo
                if (iwild .eq. 1) then
                  ee = epssampleunrestrict(it)*gasdev(idum)
                else
                  iii =  IRANDD(n)
                  ee = epssampleunrestrict(iii)
                endif
                ypow(it) = ypow(it) + dble(ee)        
             enddo
         endif
      endif
c
c     end do loop on imine
c
      enddo
c
      call gtests(pee_value_reject,pee_usual_F_theory,fstat_sample,
     1    ypow,xpow,betarestrict,n,iechodata, ilagdep,weights4mean,
     1    numvarreadin,numlag,numcause,numsim,fnumsim,numsimestprint,
     1    min_ndf,k,ndf,itaumin,itaumax,numtau,betahat,
     1    varlabel,fstat_usual_sample,numpower,ipow,iwild,nsample)
c
c 
      if (ipow .eq. 1) write(6,'(  4x,
     1'' F (thy)  F (boot) McC 10   McC 20   McC 40   McC100   '',
     1 ''median     90%    maximum  taumin   taumax'')') 
      if (ipow .le. 10) 
     1write(6,'(i2,11f9.4)')ipow, pee_value_reject(-4),
     1 pee_value_reject(-3),
     1 pee_value_reject(-5),
     1 pee_value_reject(-6),
     1 pee_value_reject(-7),
     1 pee_value_reject(-8),
     1   pee_value_reject(-19),pee_value_reject(-11),     
     1   pee_value_reject(0),pee_value_reject(itaumin),
     1   pee_value_reject(itaumax)
c
c
      do ii = -31,0
        if (pee_value_reject(ii) .le. .05)  
     1                           ipowcount(ii) = ipowcount(ii)  + 1
      enddo
      do ii = itaumin, itaumax
        if (pee_value_reject(ii) .le. .05)  
     1                           ipowcount(ii) = ipowcount(ii)  + 1
      enddo
c
c   end do loop on power simulations (ipow)
c 
     
      enddo
c
c
      fnumpower = float(numpower)
      do ii = -31,0
        power(ii) =   float(ipowcount(ii)) / fnumpower
      enddo
      write(6, '(/''Power for usual F test'',
     1            '' ( theory )                      ='',f10.4)') 
     1                                                    power(-4)
      write(6, '( ''Power for usual F test'',
     1            '' (bootstrap)                     ='',f10.4)') 
     1                                                    power(-3)
      write(6, '( ''Power for McCracken MS''
     1           ,''E-F test(  5 postsample periods) ='',f10.4)') 
     1                                                   power(-30)
      write(6, '( ''Power for McCracken MS''
     1           ,''E-F test( 10 postsample periods) ='',f10.4)') 
     1                                                    power(-5)
      write(6, '( ''Power for McCracken MS''
     1           ,''E-F test( 20 postsample periods) ='',f10.4)') 
     1                                                    power(-6)
      write(6, '( ''Power for McCracken MS''
     1           ,''E-F test( 40 postsample periods) ='',f10.4)') 
     1                                                    power(-7)
      write(6, '( ''Power for McCracken MS''
     1           ,''E-F test(100 postsample periods) ='',f10.4)') 
     1                                                    power(-8)
      write(6, '( ''Power for   minimum ove''
     1            ,''r splits                        ='',f10.4)')
     1                                                    power(-29)
      write(6, '( ''Power for    5% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-28)
      write(6, '( ''Power for   10% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-27)
      write(6, '( ''Power for   15% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-26)
      write(6, '( ''Power for   20% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-25)
      write(6, '( ''Power for   25% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-24)
      write(6, '( ''Power for   30% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-23)
      write(6, '( ''Power for   35% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-22)
      write(6, '( ''Power for   40% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-21)
      write(6, '( ''Power for   45% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-20)
      write(6, '( ''Power for      median ''
     1           ,''split                            ='',f10.4)') 
     1                                                    power(-19)
      write(6, '( ''Power for   55% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-18)
      write(6, '( ''Power for   60% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-17)
      write(6, '( ''Power for   65% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-16)
      write(6, '( ''Power for   70% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-15)
      write(6, '( ''Power for   75% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-14)
      write(6, '( ''Power for   80% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-13)
      write(6, '( ''Power for   85% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-12)
      write(6, '( ''Power for   90% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-11)
      write(6, '( ''Power for   95% quartil'',
     1             ''e split                         ='',f10.4)') 
     1                                                    power(-10)
      write(6, '( ''Power for   maximum ove''
     1            ,''r splits                        ='',f10.4)')
     1                                                    power( -9)
      write(6, '( ''Power for   mean    ove''
     1            ,''r splits                        ='',f10.4)')
     1                                                    power(-31)
      do ii = itaumin, itaumax
        power(ii) = float(ipowcount(ii))  / fnumpower
        write(6,'(''Power for split at ''i5,30x,'' ='',f10.4)') ii,
     1                                                    power(ii) 
      enddo
c
c
c end if-block on numpower < 0
c
      endif
c

c
c   Get the current date and time
c
      call date_and_time(date,time,zone,values)
      write(6,'(///''Run Ended at: (HHMM:SS:hh) '',a4,'':'',a5)')
     1 time(1:4),time(5:9)
      write(6,'(''Current Date: (MM/DD/YYYY) '',a2,''/'',a2,''/'',a4)')
     1 date(5:6),date(7:8),date(1:4)
c
      end
c
c*****************************************************************************
c
      subroutine gtests(pee_value_reject,pee_usual_F_theory,
     1   fstat_sample,
     1    ydat,xdat,beta,n,iechodata,ilagdep,weights4mean,
     1    numvarreadin,numlag,numcause,numsim,fnumsim,numsimestprint,
     1    min_ndf,k,ndf,itaumin,itaumax,numtau,betahat,
     1    varlabel,fstat_usual_sample,numpower,ipow,iwild,nsample)
c
c
      parameter(mxlaglim=40,mw=4000,maxsim=10000)
c
c  mw         = max # sample observations
c  mxlaglim   = max # regressors in regression model, including intercept
c
      real*8 ydat(-100:mw),xdat(mw,mxlaglim),
     1  ysim(-100:mw),xsim(mw,mxlaglim),
     1  ysim2nd(-100:mw),xsim2nd(mw,mxlaglim),
     1  ydat2nd(-100:mw),xdat2nd(mw,mxlaglim)
c
      real beta(mxlaglim),t(mxlaglim),pval(mxlaglim),
     1       beta4sims(mxlaglim),eps4sims(mw),
     1       betahat(mxlaglim),vcv(mxlaglim,mxlaglim),
     1       betasim(mxlaglim),epssim(mw),
     1       b1strestrict(mxlaglim,mw),b1stunrestrict(mxlaglim,mw),
     1       b2ndrestrict(mxlaglim,mw),b2ndunrestrict(mxlaglim,mw),
     1       fstat(-31:mw,0:maxsim),betahatrestrict(mxlaglim),
     1       fstat_sample(-31:mw),weights4mean(mw),
     1       pee_value_reject(-31:mw),sortinput(mw),
     1       betadontuse(mxlaglim),btemp(mxlaglim),etemp(mw)
c
      character*8 varlabel(0:mxlaglim)
      character isrt
      integer indxsorted(mw)
      real vfrac(21),frac(21)
c
c Call subroutine that computes usual F test statistic. (It prints estimates 
c only if iprint is set to one.) 
c
      if (numpower .eq. 0 .or. ipow .eq. 0) then
         iprint = 1
      else
         iprint = 0
      endif
c
c***********************************************************************
c  This section computes sample p-values for the usual F test          *  
c***********************************************************************
c
c this routine computes the restricted and unrestricted sse's          
c and betahatrestrict -- the ols parameter estimates omitting          
c the numcause putative-causing explanatory variables from the model 
c
      isim = 0
      call usual_F_stat(rss_sample,urss_sample,betahatrestrict,
     1  iprint,beta,n,
     1  numvarreadin,numlag,numcause,numsim,fnumsim,numsimestprint,
     1  min_ndf,k,ndf,itaumin,itaumax,numtau,xdat,ydat,betahat,
     1  beta4sims,eps4sims,varlabel,ipow,isim)
c
c
c  this routine computes the usual F test statistic using
c  the restricted and unrestricted sse's
c
      call fstatcalc(rss_sample,urss_sample,n-k,numcause,
     1                     fstat_usual_sample)
c
c    Its p-value based on theory is:
c
      pee_usual_F_theory =  fsig(fstat_usual_sample,numcause,n-k)
      pee_value_reject(-4)  = fsig(fstat_usual_sample,numcause,n-k)
c
      if (iprint .eq. 1) then
      write(6,'(/''Usual insample test for null of '',
     1  ''no Granger causality:''
     1/''             F =     '', f8.4,
     1/''             P =     '', f8.4 //)')
     1    fstat_usual_sample,pee_value_reject(-4)
c     1    fstat_usual_sample,pee_usual_F_theory 
      endif
c
c   store sample value of usual F statistic in zeroeth column of rows -3 & -4 
c   of fstat array; columns 1 through numsim will contain the analogous values 
c   from the simulated data.  (Rows -2, -1, and 0 are for the analogous
c   quantities for the median, 90% quantile, and max of the new statistics
c   over the itaumin ... itaumax values. )
c
      fstat(-3,0) =  fstat_usual_sample
      fstat(-4,0) =  fstat_usual_sample
      fstat_sample(-3) =  fstat_usual_sample
      fstat_sample(-4) =  fstat_usual_sample
c
c The sample value of this test statistic is entered in both row -3 and 
c row -4.  The p-value for row -4 is obtained using the usual F distribution,
c which would be correct only under the usual regression assumptions of
c fixed regressors and niid model errors.   The p-value for row -3 is obtained 
c using the wild bootstrap, the same as all the other statistics.
c
c

c***********************************************************************
c  This section computes sample p-values for the McCracken MSE-F test  *  
c***********************************************************************
c
c subroutine mccracken computes the McCracken MSE-F test statistic for the newly
c simulated data for npost =  10 periods (index = -5)      
c                    npost =  20 periods (index = -6)
c                    npost =  40 periods (index = -7)
c                    npost = 100 periods (index = -8)
c                    npost =   5 periods (index = -30)
c and stores it in column 0 of fstat array (for rows -5 ... -8 and -30).
c
      isim = 0
      call mccracken(fstat,isim,iprint,n,
     1  numvarreadin,numlag,numcause,numsim,fnumsim,numsimestprint,
     1  min_ndf,k,ndf,itaumin,itaumax,numtau,xdat,ydat,varlabel)
c
c
      do icol = -8, -5
        fstat_sample(icol) =  fstat(icol,0)
      enddo
      fstat_sample(-30) =  fstat(-30,0)
c
c
c 
c***********************************************************************
c  This section computes sample values of the new statistics           *  
c*********************************************************************** 
c
c
        fstatmax_sample = -1.e20
        do itau = itaumin, itaumax
c
c  estimate beta (restricted and unrestricted) over first interval
c
        call olsreg(ydat,xdat,btemp,etemp,t,
     1       itau,k-numcause,sse,vcv,ssqd)
        do j = 1,k-numcause
           b1strestrict(j,itau) = btemp(j)
        enddo
c
        call olsreg(ydat,xdat,btemp,etemp,t,
     1       itau,k,sse,vcv,ssqd)
        do j = 1,k
           b1stunrestrict(j,itau) = btemp(j)
        enddo
c
c
c  estimate beta (restricted and unrestricted) over second interval
c
        do it = 1,n-itau
          ydat2nd(it) = ydat(it+itau)
          do ij = 1,k
            xdat2nd(it,ij) = xdat(it+itau,ij)
          enddo
        enddo
        call olsreg(ydat2nd,xdat2nd,btemp,etemp,t,
     1       n-itau,k-numcause,sse,vcv,ssqd)
        do j = 1,k-numcause
           b2ndrestrict(j,itau) = btemp(j)
        enddo
c
        call olsreg(ydat2nd,xdat2nd,btemp,etemp,t,
     1       n-itau,k,sse,vcv,ssqd)
        do j = 1,k
           b2ndunrestrict(j,itau) = btemp(j)
        enddo
c
c
       if (iprint .eq. 1) then
       write (6,'(/12x,''first sample          second sample'')')
       do j = 1,k-numcause 
        write (6,'(a8,x,f7.4,3x,F7.4,5x,f7.4,3x,F7.4)') varlabel(j),
     1         b1stunrestrict(j,itau),b1strestrict(j,itau),
     1         b2ndunrestrict(j,itau),b2ndrestrict(j,itau)
       enddo
c
       do j = k-numcause + 1, k 
         write (6,'(a8,x,f7.4,15x,F7.4)') varlabel(j),
     1         b1stunrestrict(j,itau),b2ndunrestrict(j,itau)
       enddo
       endif
c
c  For this value of itau, calculate rss and urss using the b2nd 
c  coefficient estimates for the first itau residuals and using
c  the b1st coefficient estimates for the remaining residuals
c
      rss = 0.
      urss = 0.
c
      do it = 1, itau
c
         erestrict = ydat(it) 
         do j = 1, k-numcause
            erestrict = erestrict -  b2ndrestrict(j,itau)*xdat(it,j)
         enddo
         rss = rss + erestrict*erestrict
c
         eunrestrict = ydat(it) 
         do j = 1, k
            eunrestrict = eunrestrict 
     1                          -  b2ndunrestrict(j,itau)*xdat(it,j)
         enddo
         urss = urss + eunrestrict*eunrestrict
      enddo
c
      do it = itau + 1, n
c
         erestrict = ydat(it) 
         do j = 1, k-numcause
            erestrict = erestrict -  b1strestrict(j,itau)*xdat(it,j)
         enddo
         rss = rss + erestrict*erestrict
c
         eunrestrict = ydat(it) 
         do j = 1, k
            eunrestrict = eunrestrict 
     1                          -  b1stunrestrict(j,itau)*xdat(it,j)
         enddo
         urss = urss + eunrestrict*eunrestrict
      enddo
c
c
       call fstatcalc(rss,urss,n-k,numcause,eff)
       fstat_sample(itau) =  eff
       fstat(itau,0) =  eff
c        
       if (eff .gt. fstatmax_sample) fstatmax_sample = eff
c
c
      if (iprint .eq. 1) then
         write (6,'(''For itau = '',i5,'' F statistic ='',f20.6)') 
     1          itau ,fstat_sample(itau)
      endif
c
c  end loop on itau
c
        enddo
c
c    fstat_sample(0) will be the maximum value of 
c        fstat_sample(itaumin) ... fstat_sample(itaumax)
c    which is obtained within the itau loop.  
c
      fstat_sample(-9) =   fstatmax_sample
      fstat(-9,0) =  fstatmax_sample
c
c
c  Next sort the values fstat_sample(itaumin) ... fstat_sample(itaumax)
c  to find the quantile  values.  These will be stored in 
c  fstat_sample(-29)to fstat_sample(-9.
c
      num2sort = itaumax - itaumin + 1
      do itau = itaumin,itaumax
        sortinput(itau -itaumin + 1)= fstat_sample(itau)
      enddo
c
c
c   code for invoking sort routine to compute fractiles
c
        isrt = 'B'
        nfrac = 21
        frac( 1) = 0.0
        frac( 2) = .05
        frac( 3) = .10
        frac( 4) = .15
        frac( 5) = .20
        frac( 6) = .25
        frac( 7) = .30
        frac( 8) = .35
        frac( 9) = .40
        frac(10) = .45
        frac(11) = .50
        frac(12) = .55
        frac(13) = .60
        frac(14) = .65
        frac(15) = .70
        frac(16) = .75
        frac(17) = .80
        frac(18) = .85
        frac(19) = .90
        frac(20) = .95
        frac(21) = 1.00
        call sort(indxsorted,sortinput,num2sort,nfrac,
     1           frac,vfrac,isrt,8)
        fstat_sample(-29) = vfrac( 1)
        fstat_sample(-28) = vfrac( 2)
        fstat_sample(-27) = vfrac( 3)
        fstat_sample(-26) = vfrac( 4)
        fstat_sample(-25) = vfrac( 5)
        fstat_sample(-24) = vfrac( 6)
        fstat_sample(-23) = vfrac( 7)
        fstat_sample(-22) = vfrac( 8)
        fstat_sample(-21) = vfrac( 9)
        fstat_sample(-20) = vfrac(10)
        fstat_sample(-19) = vfrac(11)
        fstat_sample(-18) = vfrac(12)
        fstat_sample(-17) = vfrac(13)
        fstat_sample(-16) = vfrac(14)
        fstat_sample(-15) = vfrac(15)
        fstat_sample(-14) = vfrac(16)
        fstat_sample(-13) = vfrac(17)
        fstat_sample(-12) = vfrac(18)
        fstat_sample(-11) = vfrac(19)
        fstat_sample(-10) = vfrac(20)
        fstat_sample(-9 ) = vfrac(21)
c
        fstat(-29,0) = vfrac( 1)
        fstat(-28,0) = vfrac( 2)
        fstat(-27,0) = vfrac( 3)
        fstat(-26,0) = vfrac( 4)
        fstat(-25,0) = vfrac( 5)
        fstat(-24,0) = vfrac( 6)
        fstat(-23,0) = vfrac( 7)
        fstat(-22,0) = vfrac( 8)
        fstat(-21,0) = vfrac( 9)
        fstat(-20,0) = vfrac(10)
        fstat(-19,0) = vfrac(11)
        fstat(-18,0) = vfrac(12)
        fstat(-17,0) = vfrac(13)
        fstat(-16,0) = vfrac(14)
        fstat(-15,0) = vfrac(15)
        fstat(-14,0) = vfrac(16)
        fstat(-13,0) = vfrac(17)
        fstat(-12,0) = vfrac(18)
        fstat(-11,0) = vfrac(19)
        fstat(-10,0) = vfrac(20)
        fstat(-9,0)  = vfrac(21)
c
c
c     now compute mean statistic: (#31)
c
c   from a bit earlier:       num2sort = itaumax - itaumin + 1
c
      fstat(-31,0)  = 0.
      do itau = itaumin,itaumax
        fstat(-31,0)  =  fstat(-31,0) 
     1       +  fstat_sample(itau)*weights4mean(itau)
      enddo
      fstat_sample(-31) =  fstat(-31,0)
c
c
c  Imposing the null hypothesis of no Granger-causation, so as to test same,
c   the beta vector for generating simulated data is from the restricted model
c    this was calculated in "usual_F_stat" routine when it was called with isim=0
c
c      do ik = 1,k -numcause
c        beta4sims(ik) =  betahatrestrict(ik)
c       write(6,'(''beta4sims = '',f20.8,'' for ik ='', i5)')
c    1          beta4sims(ik),ik
c      enddo
c
c  the columns for the fixed-in-repeated samples variates
c  are the same for every simulation:
c
      do it = 1, n
        do ik = numlag + 1, k 
          xsim(it,ik) = xdat(it,ik)
        enddo
      enddo    
c
c
c  Start monte carlo simulation loop for obtaining p-values for rejecting
c  null hypothesis of no granger causation, using each of these statistics:
c
c     fstat_sample(-8)... fstat_sample(-5) (for McCraken tests)
c     fstat_sample(-4)  = usual f statistic, computed earlier in this routine
c     fstat_sample(-3)  = usual f statistic, computed earlier in this routine
c     fstat_sample(-2)  = median 
c                           of fstat_sample(itaumin) ... fstat_sample(itaumax)
c     fstat_sample(-1)  = 90% fractile 
c                           of fstat_sample(itaumin) ... fstat_sample(itaumax)
c     fstat_sample(0)  = maximum 
c                           of fstat_sample(itaumin) ... fstat_sample(itaumax)
c     fstat_sample(itaumin) 
c       and so forth, through
c     fstat_sample(itaumax) 
c
c  by finding out what fraction of the numsim analogous test statistics (for 
c  data simulated under the null) exceed these values
c
c
      do isim = 1, numsim
      if ( mod(isim,1000) .eq. 0) 
     1 write(*,'('' working on simulation '',i5,'' out of '',i5)')
     1        isim,numsim 
c
c   Generate the new data for this simulation, using the (restricted) OLS model 
c   for the data read in and the wild bootstrap.  The simulations must account
c   for the dynamics (and randomly bootastrapped start-up values) if there 
c   are lagged dependent variables -- these are assumed to be in columns 1 through 
c   numlag of the X matrix; the other explanatory variables are treated as 
c   "fixed in repeated samples" and the model coefficients are fixed at the 
c   estimates (betahatrestrict) from the restricted model, which imposes the
c   null hypothesis of no granger causality.
c        
c   Note that wild bootstrap is implemented by multiplying eps4sims(it) by the niid(0,1)
c   variate produced by gasdev(idum).
c
c
      if (numlag .gt. 0) then
        if (ilagdep .eq. 0) then 
            do ilag = 1-numlag, 0
c
c              the lagged dependent variable is chosen (at random) over the
c                 n values of ydat if ilagdep = 0 
               iii =  IRANDD(n)
               ysim(ilag) = ydat(iii)
            enddo
        else
            do ilag = 1-numlag, 0
               iii = 1 + ilag
               ysim(ilag)  = xdat(1, iii)
            enddo
        endif
c
        do it = 1, n
          do ilag = 1, numlag
            xsim(it,ilag) = ysim(it - ilag)
          enddo        
          ysim(it) = 0.d0
          do ik = 1, k - numcause
            ysim(it) = ysim(it) + dble(beta4sims(ik))*xsim(it,ik)
          enddo
          if (iwild .eq. 1) then
             ee = eps4sims(it)*gasdev(idum)
          else
             iii =  IRANDD(n)
             ee = eps4sims(iii)
          endif
c         ysim(it) = ysim(it) + dble(gasdev(idum))
          ysim(it) = ysim(it) + dble(ee)
        enddo
      else
        do it = 1, n
          ysim(it) = 0.d0
          do ik = 1, k - numcause
            ysim(it) = ysim(it) + dble(beta4sims(ik))*xsim(it,ik)
          enddo
          if (iwild .eq. 1) then
             ee = eps4sims(it)*gasdev(idum)
          else
             iii =  IRANDD(n)
             ee = eps4sims(iii)
          endif
c         ysim(it) = ysim(it) + dble(gasdev(idum))
          ysim(it) = ysim(it) + dble(ee)
        enddo  
      endif
c
c**************************
c  for testing write out first simulated data set
c**************************
c
c     write(6,'(''isim = '',i5,'' beta4sims = '',4F15.5)')isim,
c    1 beta4sims(1), 
c    1               beta4sims(2),beta4sims(3),beta4sims(4)
c   writes the generated data out to csv file for 1st simulated
c
c     if (isim .eq. 1 .and. ipow .eq. 0) then
c        open(13,file='crossgranger_data_firstsimulated.csv')
c        write (13,'(100(a8,'' , ''))') (varlabel(jj),jj= 0,k)
c        do it = 1, n
c           write (13,'(100(f20.8,'' , ''))')
c    1          ysim(it),(xsim(it,jj), jj=1,k)
c        enddo
c        close (13)
c     endif
c
c   writes the generated data out to csv file for first powersim
c
c     if (isim .eq. 1 .and. ipow .eq. 1) then
c        open(14,file='crossgranger_data_firstpoweresim.csv')
c        write (14,'(100(a8,'' , ''))') (varlabel(jj),jj= 0,k)
c        do it = 1, n
c           write (14,'(100(f20.8,'' , ''))')
c    1          ysim(it),(xsim(it,jj), jj=1,k)
c        enddo
c        close (14)
c     endif
c
c
c***********************************************************************
c  This section computes sample p-values for the usual F test          *  
c  using this newly simulated data                                     *
c***********************************************************************
c
c calculate and store the usual F statistic for these new simulated data
c  
      iprint = 0
c
c     if (isim .eq. 1) then
c       open(16,file='datasim1out.csv')
c      write(16,'(''ysim,ylag,const,r,s,t'')')
c      do j= 1,n
c        write (16,'(200(f20.8,'' , ''))')ysim(j),
c    1      (xsim(j,ik), ik = 1,5)
c      enddo
c      close (16)
c     endif
      call usual_F_stat(rss,urss,betadontuse,
     1  iprint,beta,n,
     1  numvarreadin,numlag,numcause,numsim,fnumsim,numsimestprint,
     1  min_ndf,k,ndf,itaumin,itaumax,numtau,xsim,ysim,betahat,
     1  beta4sims,eps4sims,varlabel,ipow,isim)
c
c
      call fstatcalc(rss,urss,n-k,numcause,fstat_usual)
c
c     subroutine fstatcalc(r,u,ndf,numcause,eff)
c     essqrd = u/float(ndf)
c     eff = ( (r-u)/float(numcause) )  /  essqrd
c     return
c     end
c
c   store sample value of usual F statistic in isim-eth column of row -3 
c   of fstat array for bootstrap case.  (It is not needed in row 4  because 
c   p-value is in this case calculated using tail area of F distribution.)
c    Columns 1, numsim thus contain the values 
c   from the simulated data.  (Rows -2, -1, and 0 are for the analogous
c   quantities for the median, 90% quantile, and max of the new statistics
c   over the itaumin ... itaumax values. )
c
      fstat(-3,isim) =  fstat_usual
c     write (6,'('' for isim ='',i5,'' and ipow = '', i5,
c    1 '' rss = '',f20.8, '' urss = '',f20.8,
c    1 '' fstat_usual = '', f20.8)')isim, ipow, rss, urss,fstat_usual
c
c      fstat(-4,isim) =  fstat_usual
c
c
c
c***********************************************************************
c  This section computes sample p-values for the McCracken MSE-F test  *  
c***********************************************************************
c
c
c subroutine mccracken computes the McCracken MSE-F test statistic for the newly
c simulated data for npost =  10 periods (index = -5)         
c                    npost =  20 periods (index = -6)
c                    npost =  40 periods (index = -7)
c                    npost = 100 periods (index = -8)
c                    npost =   5 periods (index = -30)
c and stores it in column isim of fstat array (for rows -5 ... -8 and -30).
c
      call mccracken(fstat,isim,iprint,n,
     1  numvarreadin,numlag,numcause,numsim,fnumsim,numsimestprint,
     1  min_ndf,k,ndf,itaumin,itaumax,numtau,xsim,ysim,varlabel)
c
c 
c***********************************************************************
c  This section computes sample p-values for the new test statistics   *  
c  using this newly simulated data                                     *
c***********************************************************************
c
c
c  compute and print regression output (and first ten simulated
c  observations) if and only if  isim <= numsimestprint
c
c
c       estimate OLS model for the simulated data
c
        call olsreg(ysim,xsim,betasim,epssim,t,n,k,sse,vcv,ssqd) 
        ndf = n - k
        do ik = 1,k
           tcoef = t(ik)
           pval(ik)=  tsig(tcoef,ndf)
        enddo
c
        ymean = 0.
        do i = 1,n
            ymean = ymean + real(ysim(i))
        enddo
        ymean = ymean/float(n)
        vary = 0.
        do i = 1,n
            vary = vary +(real(ysim(i)) - ymean)**2
        enddo
        vary = vary/float(n-1)
        rsqrdadj = 1. - (ssqd/vary)
c
c
      if (iprint .eq. 1) then
        if (isim .le. numsimestprint) 
     1     write(6,'(///''For simulation number'', i3,'':''/)')isim
c
c
        if (iechodata .gt. 0 .and. isim .le. numsimestprint) then
          write(6,'(''First '', i5,
     1      '' simulated observations on dependent'',
     1       '' and explanatory variables:'')')  iechodata
          do i = 1,iechodata
            write(6,'(i2,2x,100e12.5)')i,ysim(i),(xsim(i,j), j=1,k)
          enddo 
        endif
c
c
       if (isim .le. numsimestprint) then
        write(6,'(/a8,x,
     1  ''truecoef    coef      t ratio   sig. level'')')  varlabel(0)
         do ik = 1,k
          write(6,'(a8,x,f7.4,3x,F7.4,3x,f9.3,f11.3)') varlabel(ik),
     1                 beta(ik),betasim(ik),t(ik),pval(ik)
         enddo
c
c     
       write (6, '(/''s-squared      = '',e20.8)')ssqd
       write (6, '(''adj. R-squared = '',e20.8/)')rsqrdadj
      endif
c
c     ends if block on iprint:
c
      endif
c
      do itau = itaumin, itaumax
c
c print first interval
c
      if (iprint .eq. 1) then
      if (isim .le. numsimestprint) then
        write(6,'(/''for itau = '',i5,'' first sample is [    1 , '',i5,
     1              '']    ndf  = '',i5)') itau ,itau, itau-k
        write(6,'(''           '',5x,''  2nd  sample is ['',i5,
     1   '' , '',i5,'']    ndf  = '',i5)') itau +1 , n, n-itau-k
      endif
      endif
c
c  estimate beta (restricted and unrestricted) over first interval
c
        call olsreg(ysim,xsim,btemp,etemp,t,
     1       itau,k-numcause,sse,vcv,ssqd)
        do j = 1,k-numcause
           b1strestrict(j,itau) = btemp(j)
        enddo
c
        call olsreg(ysim,xsim,btemp,etemp,t,
     1       itau,k,sse,vcv,ssqd)
        do j = 1,k
           b1stunrestrict(j,itau) = btemp(j)
        enddo
c
c
c  estimate beta (restricted and unrestricted) over second interval
c
        do it = 1,n-itau
          ysim2nd(it) = ysim(it+itau)
          do ij = 1,k
            xsim2nd(it,ij) = xsim(it+itau,ij)
          enddo
        enddo
        call olsreg(ysim2nd,xsim2nd,btemp,etemp,t,
     1       n-itau,k-numcause,sse,vcv,ssqd)
        do j = 1,k-numcause
           b2ndrestrict(j,itau) = btemp(j)
        enddo
c
        call olsreg(ysim2nd,xsim2nd,btemp,etemp,t,
     1       n-itau,k,sse,vcv,ssqd)
        do j = 1,k
           b2ndunrestrict(j,itau) = btemp(j)
        enddo
c
      if (iprint .eq. 1) then
      if (isim .le. numsimestprint) then
       write (6,'(/12x,''first sample          second sample'')')
       do j = 1,k-numcause 
        write (6,'(a8,x,f7.4,3x,F7.4,5x,f7.4,3x,F7.4)') varlabel(j),
     1         b1stunrestrict(j,itau),b1strestrict(j,itau),
     1         b2ndunrestrict(j,itau),b2ndrestrict(j,itau)
       enddo
c
       do j = k-numcause + 1, k 
         write (6,'(a8,x,f7.4,15x,F7.4)') varlabel(j),
     1         b1stunrestrict(j,itau),b2ndunrestrict(j,itau)
       enddo
      endif
      endif
c
c
c
c  For this value of itau, calculate rss and urss using the b2nd 
c  coefficient estimates for the first itau residuals and using
c  the b1st coefficient estimates for the remaining residuals
c
      rss = 0.
      urss = 0.
c
      do it = 1, itau
c
         erestrict = ysim(it) 
         do j = 1, k-numcause
            erestrict = erestrict -  b2ndrestrict(j,itau)*xsim(it,j)
         enddo
         rss = rss + erestrict*erestrict
c
         eunrestrict = ysim(it) 
         do j = 1, k
            eunrestrict = eunrestrict 
     1                          -  b2ndunrestrict(j,itau)*xsim(it,j)
         enddo
         urss = urss + eunrestrict*eunrestrict
      enddo
c
      do it = itau + 1, n
c
         erestrict = ysim(it) 
         do j = 1, k-numcause
            erestrict = erestrict -  b1strestrict(j,itau)*xsim(it,j)
         enddo
         rss = rss + erestrict*erestrict
c
         eunrestrict = ysim(it) 
         do j = 1, k
            eunrestrict = eunrestrict 
     1                          -  b1stunrestrict(j,itau)*xsim(it,j)
         enddo
         urss = urss + eunrestrict*eunrestrict
      enddo
c
c
      call fstatcalc(rss,urss,n-k,numcause,eff)
      fstat(itau,isim) =  eff
c
      if (iprint .eq. 1) then
      if (isim .le. numsimestprint) then
         write (6,'(''For itau = '',i5,'' F statistic ='',f20.6)') 
     1          itau ,fstat(itau,isim)
      endif
      endif
c
c
c  end loop on itau
c
        enddo
c
c
c  Next sort the values fstat(itaumin,isim) ... fstat(itaumax,isim)
c  to find the quantiles.  These will be stored in 
c  fstat(-29,isim), fstat(-28,isim), and fstat(-9,isim), respectively.
c
      num2sort = itaumax - itaumin + 1
      do itau = itaumin,itaumax
        sortinput(itau -itaumin + 1)= fstat(itau,isim)
      enddo
c
       call sort(indxsorted,sortinput,num2sort,nfrac,
     1           frac,vfrac,isrt,8)
c        
        fstat(-16,isim) = vfrac( 1)
        fstat(-15,isim) = vfrac( 2)
        fstat(-14,isim) = vfrac( 3)
        fstat(-13,isim) = vfrac( 4)
        fstat(-12,isim) = vfrac( 5)
        fstat(-11,isim) = vfrac( 7)
        fstat(-10,isim) = vfrac( 8)
        fstat( -9,isim) = vfrac( 9)
        fstat( -2,isim) = vfrac( 6)
        fstat( -1,isim) = vfrac(10)
        fstat(  0,isim) = vfrac(11)
        fstat(-29,isim) = vfrac( 1)
        fstat(-28,isim) = vfrac( 2)
        fstat(-27,isim) = vfrac( 3)
        fstat(-26,isim) = vfrac( 4)
        fstat(-25,isim) = vfrac( 5)
        fstat(-24,isim) = vfrac( 6)
        fstat(-23,isim) = vfrac( 7)
        fstat(-22,isim) = vfrac( 8)
        fstat(-21,isim) = vfrac( 9)
        fstat(-20,isim) = vfrac(10)
        fstat(-19,isim) = vfrac(11)
        fstat(-18,isim) = vfrac(12)
        fstat(-17,isim) = vfrac(13)
        fstat(-16,isim) = vfrac(14)
        fstat(-15,isim) = vfrac(15)
        fstat(-14,isim) = vfrac(16)
        fstat(-13,isim) = vfrac(17)
        fstat(-12,isim) = vfrac(18)
        fstat(-11,isim) = vfrac(19)
        fstat(-10,isim) = vfrac(20)
        fstat(-9, isim) = vfrac(21)  
c
c
c     now compute mean statistic: (#31)
c
c   from earlier:       num2sort = itaumax - itaumin + 1
c
      fstat(-31,isim)  = 0.
      do itau = itaumin,itaumax
        fstat(-31,isim)  =  fstat(-31,isim) 
     1         + fstat(itau,isim)*weights4mean(itau)
      enddo
c
c  end loop on isim
c      
      enddo  
c
c      
c
c
      do icolumn = itaumin, itaumax
        pee_value_reject(icolumn) = 0.
        do isim = 1,numsim
            if (fstat(icolumn,isim) .gt. fstat(icolumn,0))
     1        pee_value_reject(icolumn) = pee_value_reject(icolumn) + 1
        enddo
        pee_value_reject(icolumn) 
     1          = pee_value_reject(icolumn)/fnumsim
      enddo
c
c
      do icolumn = -31, -9
        pee_value_reject(icolumn) = 0.
        do isim = 1,numsim
            if (fstat(icolumn,isim) .gt. fstat(icolumn,0))
     1        pee_value_reject(icolumn) = pee_value_reject(icolumn) + 1
        enddo
        pee_value_reject(icolumn) 
     1          = pee_value_reject(icolumn)/fnumsim
      enddo
c  
c
      do icolumn = -3,0
        pee_value_reject(icolumn) = 0.
        do isim = 1,numsim
            if (fstat(icolumn,isim) .gt. fstat(icolumn,0))
     1        pee_value_reject(icolumn) = pee_value_reject(icolumn) + 1
        enddo
        pee_value_reject(icolumn) 
     1          = pee_value_reject(icolumn)/fnumsim
      enddo
c          
c
c 
c******************************************************************************
c  This section computes sample p-values for the McCracken MSE-F statistics   *  
c  using this newly simulated data                                            *
c******************************************************************************
c
c        sample value of test statistic is in column zero
c
      do icolumn = -8,-5
        pee_value_reject(icolumn) = 0.
        do isim = 1,numsim
            if (fstat(icolumn,isim) .gt. fstat(icolumn,0))
     1        pee_value_reject(icolumn) = pee_value_reject(icolumn) + 1
        enddo
        pee_value_reject(icolumn) 
     1          = pee_value_reject(icolumn)/fnumsim
      enddo
c
c
      pee_value_reject(-30) = 0.
      do isim = 1,numsim
            if (fstat(-30,isim) .gt. fstat(-30,0))
     1        pee_value_reject(-30) = pee_value_reject(-30) + 1
      enddo
      pee_value_reject(-30) 
     1          = pee_value_reject(-30)/fnumsim
c
c   writes the fstat array out to csv file
c
c     if (ipow .eq. 0) then
c       open(15,file='xxx.csv')
c      open(15,file='crossgranger_fstat.csv')
c      write(15,'(''-8,-7,-6,-5,-4,-3,-2,-1,0'')')
c      do isim = 0, numsim
c        write (15,'(200(f20.8,'' , ''))')
c    1      (fstat(jj,isim), jj= -8, 0),
c    1      (fstat(jj,isim), jj= itaumin,itaumax)
c      enddo
c      close (15)
c     endif
c
c

      return
      end
c
C***********************************************************************
      function IRANDD(k)
C
C  THIS ROUTINE GENERATES IR, an integer RANDOMLY
C  DISTRIBUTED ON THE INTERVAL [1,K].  FOR SOME USES IT IS
C  UNSUITABLE FOR USE WITH LARGE VALUES OF K SINCE THE
C  UNDERLYING LINEAR CONGRUENTIAL GENERATOR YIELDS INTEGERS IN
C  THE INTERVAL [1,714025]. IN PARTICULAR, YOU HAD BETTER NOT CALL
C  THIS ROUTINE WITH K > 3000 OR IT WILL YIELD INTEGER OVERFLOWS
C  INTO NEGATIVE NUMBERS.
C
C
      COMMON /RANSET/FIMM,IMM,IAA,ICC,IDUM,IY,IDECK(97)
C
C
C
C
C  CALCULATE INDEX OF IDECK ARRAY TO READ RANDOM NUMBER FROM:
C
      J = 1 + (97*IY)/IMM
C
C  STORE GENERATOR FOR NEW POINTER
C
      IY = IDECK(J)
C
C  ALSO USE IDECK(J) TO GENERATE ITH ELEMENT OF IR VECTOR
C
C
        irandd =  1 + (K*IDECK(J))/IMM
C
C
C  USE PREVIOUS SEED TO GENERATE NEW RANDOM NUMBER TO REPLACE
C  ELEMENT OF IDECK JUST USED
C
      IDUM = MOD(IAA*IDUM +ICC,IMM)
      IDECK(J) = IDUM
C
C
      RETURN
C
C
      END
c*****************************************************************
      function tsig(tin,ndf)
c
c    tsig is probability that magnitude of a student's t variate
c    with ndif degrees of freedom will exceed tin -- i.e., area
c    under both tails.
c
c   needs gammlon, betai and betacf
c
      v1 = 1.
      v2 = real(ndf)
      eff = tin*tin
c tail area to the right of F distribution with (v1,v2) dfs
c is betai(v2/2, v1/2, v2/(v2+v1F)  )
c(Press, et al. p169)
      s = v2/(v2 + v1*eff)
      tsig = betai(v2/2. , v1/2. , s)
c
      return
      end
c*****************************************************************
      function fsig(fin,ndfnume,ndfdenom)
c
c    fsig is probability that magnitude of an F t variate
c    with ndfnume degrees of freedom in the numerator and
c    ndfdenomwdegrees of freedom in the denominator will 
c    exceed fin -- i.e., area  under the upper tail.
c
c   needs gammlon, betai and betacf
c
      v1 = float(ndfnume)
      v2 = float(ndfdenom)
      eff = abs(fin)
c tail area to the right of F distribution with (v1,v2) dfs
c is betai(v2/2, v1/2, v2/(v2+v1F)  )
c(Press, et al. p169)
      s = v2/(v2 + v1*eff)
      fsig = betai(v2/2. , v1/2. , s)
      return
      end
c====================================================================
c-----------------------------------------------------------------------------
      FUNCTION GAMMLON(XX)
      REAL*8 COF(6),STP,HALF,ONE,FPF,X,TMP,SER
      DATA COF,STP/76.18009173D0,-86.50532033D0,24.01409822D0,
     *    -1.231739516D0,.120858003D-2,-.536382D-5,2.50662827465D0/
      DATA HALF,ONE,FPF/0.5D0,1.0D0,5.5D0/
      X=XX-ONE
      TMP=X+FPF
      TMP=(X+HALF)*LOG(TMP)-TMP
      SER=ONE
      DO 11 J=1,6
        X=X+ONE
        SER=SER+COF(J)/X
11    CONTINUE
      GAMMLON=TMP+LOG(STP*SER)
      RETURN
      END
      FUNCTION BETAI(A,B,X)
c
c tail area to the right of F distribution with (v1,v2) dfs
c is betai(v2/2, v1/2, v2/(v2+v1F)  )
c(Press, et al. p169)
c
c     IF(X.LT.0..OR.X.GT.1.)PAUSE 'bad argument X in BETAI'
      IF(X.LT. -.00001 .OR. X.GT. 1.00001)
     1      PAUSE 'bad argument X in BETAI'
      IF(abs(x) .le. 1.e-5) x = .00001
      IF(abs(x - 1.) .le. 1.e-5) x = .99999
      IF(X.EQ.0..OR.X.EQ.1.)THEN
        BT=0.
      ELSE
        BT=EXP(GAMMLON(A+B)-GAMMLON(A)-GAMMLON(B)
     *      +A*ALOG(X)+B*ALOG(1.-X))
      ENDIF
      IF(X.LT.(A+1.)/(A+B+2.))THEN
        BETAI=BT*BETACF(A,B,X)/A
        RETURN
      ELSE
        BETAI=1.-BT*BETACF(B,A,1.-X)/B
        RETURN
      ENDIF
      END
      FUNCTION BETACF(A,B,X)
      PARAMETER (ITMAX=100,EPS=3.E-7)
      AM=1.
      BM=1.
      AZ=1.
      QAB=A+B
      QAP=A+1.
      QAM=A-1.
      BZ=1.-QAB*X/QAP
      DO 11 M=1,ITMAX
        EM=M
        TEM=EM+EM
        D=EM*(B-M)*X/((QAM+TEM)*(A+TEM))
        AP=AZ+D*AM
        BP=BZ+D*BM
        D=-(A+EM)*(QAB+EM)*X/((A+TEM)*(QAP+TEM))
        APP=AP+D*AZ
        BPP=BP+D*BZ
        AOLD=AZ
        AM=AP/BPP
        BM=BP/BPP
        AZ=APP/BPP
        BZ=1.
        IF(ABS(AZ-AOLD).LT.EPS*ABS(AZ))GO TO 1
11    CONTINUE
      PAUSE 'A or B too big, or ITMAX too small'
1     BETACF=AZ
      RETURN
      END
      FUNCTION GASDEV(IDUM)
      common /gassav/ gset,iset
      IF (ISET.EQ.0) THEN
1       V1=2.*UNIF(IDUM)-1.
        V2=2.*UNIF(IDUM)-1.
        R=V1**2+V2**2
        IF(R.GE.1.)GO TO 1
        FAC=SQRT(-2.*LOG(R)/R)
        GSET=V1*FAC
        GASDEV=V2*FAC
        ISET=1
      ELSE
        GASDEV=GSET
        ISET=0
      ENDIF
C
      RETURN
C
      END
c===================================================================
      function unif(idum)
c
c  from numerical recipes p.196  The only modification made here is to
c  get rid of IFF and put the R array into labelled common so that it is
c  remembered  between invocations.  Initialize by invoking with idum
c  negative; routine then returns idum = 0
c----------------------------------------------------------
      common /unigen/ R(97),IX1,IX2,IX3
c---------------------------------------------------------
      PARAMETER (M1=259200,IA1=7141,IC1=54773,RM1=3.8580247E-6)
      PARAMETER (M2=134456,IA2=8121,IC2=28411,RM2=7.4373773E-6)
      PARAMETER (M3=243000,IA3=4561,IC3=51349)
      IF (IDUM.LT.0) THEN
        IX1=MOD(IC1-IDUM,M1)
        IX1=MOD(IA1*IX1+IC1,M1)
        IX2=MOD(IX1,M2)
        IX1=MOD(IA1*IX1+IC1,M1)
        IX3=MOD(IX1,M3)
        DO 11 J=1,97
          IX1=MOD(IA1*IX1+IC1,M1)
          IX2=MOD(IA2*IX2+IC2,M2)
          R(J)=(FLOAT(IX1)+FLOAT(IX2)*RM2)*RM1
11      CONTINUE
        idum = 0
      ENDIF
      IX1=MOD(IA1*IX1+IC1,M1)
      IX2=MOD(IA2*IX2+IC2,M2)
      IX3=MOD(IA3*IX3+IC3,M3)
      J=1+(97*IX3)/M3
      IF(J.GT.97.OR.J.LT.1) then
         write(*,*)' Problem in UNIF generator'
         pause
      endif
      UNIF=R(J)
      R(J)=(FLOAT(IX1)+FLOAT(IX2)*RM2)*RM1
      RETURN
      END
c
c====================================================================
c
      subroutine olsreg(y,x,beta,eps,t,n,k,sse,vcv,ssqd)
c     call olsreg(ydat,xdat,betahat,eps,t,n,k,sse,vcv,ssqd)
c      real*8 ydat(mw),xdat(mw,mxlaglim)
c      real beta(mxlaglim),t(mxlaglim),pval(mxlaglim),eps(mw),
c     1       betahat(mxlaglim),vcv(mxlaglim,mxlaglim)
      parameter(mxlaglim=40,mw=4000)
      real*4 beta(mxlaglim),T(mxlaglim),eps(mw),vcv(mxlaglim,mxlaglim)
      integer indx(MXLAGLIM)
      REAL*8 XTX(MXLAGLIM,MXLAGLIM),XTY(MXLAGLIM),Y(-100:MW),
     1   vv(mxlaglim),X(MW,MXLAGLIM)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                     c
C               ESTIMATES Y = X*BETA + EPS                            c
C     VIA OLS WITH DOUBLE PRECISION LU FACTORIZATION                  c
C                                                                     c
C  NOTE: THIS ROUTINE ASSUMES X MATRIX HAS COLUMN OF ONES IF          c
C        THERE IS AN INTERCEPT.                                       c
C                                                                     c
C                                                                     c
C   INPUTS    N    = # OF OBSERVATIONS                                c
C             K    = # OF PARAMETERS TO ESTIMATE                      c
C             Y    = Nx1 VECTOR OF DEPENDENT VARIABLE DATA            c
C             X    = NxK MATRIX OF EXPLANATORY VARIABLE DATA          c
C                                                                     c
C   OUTPUTS   BETA = Kx1 ESTIMATED PARAMETER VECTOR                   c
C             EPS  = Nx1 FITTING ERROR VECTOR                         c
C             T    = Kx1 VECTOR OF ESTIMATED T RATIOS                 c
C             SSE  = SUM OF SQUARED FITTING ERRORS                    c
C             VCV  = ESTIMATED VARIANCE-COVARIANCE MATRIX             c
C                                                                     c
C   USAGE NOTE: REMEMBER TO DIMENSION Y,X,BETA,EPS, AND T             c
C               SUITABLY IN CALLING PROGRAM                           c
C                                                                     c
C                                                                     c
C   USES ROUTINES BASED ON PRESS, ET AL. LUDCMP AND LUBKSB CODES.     c
Ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  FORM X-TRANSPOSE*X MATRIX:
C
      DO I = 1,K
      DO J = 1,I
         XTX(I,J) = 0.D0
         DO IT = 1,N
           XTX(I,J) = XTX(I,J) + X(IT,I)*X(IT,J)
         ENDDO
         XTX(J,I) = XTX(I,J)
      ENDDO
      ENDDO
C
C  FORM X-TRANSPOSE * Y VECTOR:
C
      DO J = 1,K
         XTY(J) = 0.D0
         DO IT = 1,N
           XTY(J) = XTY(J) + X(IT,J)*Y(IT)
         ENDDO
      ENDDO
C
C
C  OBTAIN LU FACTORIZATION OF XTX
C
      call dludcmp(xtx,vv,k,indx,mxlaglim)
C
C   XTX NOW CONTAINS LU FACTORIZATION OF ORIGINAL XTX
C
C   NEXT SOLVE FOR BETA:
C
      call dlubksb(xtx,k,indx,xty,mxlaglim)
      DO J = 1,K
        BETA(J) = SNGL(XTY(J))
      ENDDO
C
C  NOW CALCULATE THE DIAGONAL ELEMENTS OF THE INVERSE OF ORIGINAL XTX
C  MATRIX, STORING THEM TEMPORARILY IN THE T ARRAY.  DO THIS BY
C  RE-SOLVING THE NORMAL EQUATIONS, REPLACING XTY VECTOR BY EACH UNIT
C  VECTOR IN TURN.  SIMILARLY, ALL ELEMENTS OF THE INVERSE GO INTO VCV.
C
      DO ICOF = 1,K
C
          DO J = 1,K
            XTY(J) = 0.D0
          ENDDO
          XTY(ICOF) = 1.D0
C
          call dlubksb(xtx,k,indx,xty,mxlaglim)
          T(ICOF) = SNGL(XTY(ICOF))
          DO JCOF = 1,K
             VCV(ICOF,JCOF)= SNGL(XTY(JCOF))
          ENDDO
      ENDDO
C
C
C  CALCULATE THE FITTING ERRORS, SSE, AND S-SQUARED:
C
      SSE = 0.
      DO IT = 1,N
        EPS(IT) = Y(IT)
        DO ICOF = 1,K
           EPS(IT) = EPS(IT) - beta(ICOF)*X(IT,ICOF)
        ENDDO
           SSE = SSE + EPS(IT)**2
      ENDDO
      SSQD = SSE/FLOAT(N-K)
C
C  CALCULATE T RATIOS (AT THIS POINT T ARRAY CONTAINS DIAGONAL OF
C                      INVERSE OF X-TRANSPOSE*X MATRIX)
C
      DO ICOF = 1,K
        zed = (beta(icof)*beta(icof))/(t(icof)*ssqd)
        if (zed .ge. 1.e-8) then
          T(ICOF) =  (BETA(ICOF)/abs(beta(icof))) * sqrt(zed)
        else
          T(ICOF) =  (BETA(ICOF)/abs(beta(icof))) * 1.e-4
        endif
      ENDDO
C
C
C
C  CALCULATE VARIANCE-COVARIANCE MATRIX, VCV. (AT THIS POINT VCV
C  ARRAY CONTAINS INVERSE OF X-TRANSPOSE*X MATRIX)
C
      DO ICOF = 1,K
      DO JCOF = 1,K
        VCV(ICOF,JCOF) =  SSQD*VCV(ICOF,JCOF)
      ENDDO
      ENDDO
C
C
      RETURN
      END
c
c===================================================================
      subroutine dlubksb(a,n,indx,b,mxlaglim)
      real*8 A(mxlaglim,mxlaglim),B(mxlaglim),sum
      integer indx(mxlaglim)
c----------------------------------------------------
      II=0
      DO 12 I=1,N
        LL=INDX(I)
        SUM=B(LL)
        B(LL)=B(I)
        IF (II.NE.0)THEN
          DO 11 J=II,I-1
            SUM=SUM-A(I,J)*B(J)
11        CONTINUE
        ELSE IF (SUM.NE.0.D0) THEN
          II=I
        ENDIF
        B(I)=SUM
12    CONTINUE
      DO 14 I=N,1,-1
        SUM=B(I)
        IF(I.LT.N)THEN
          DO 13 J=I+1,N
            SUM=SUM-A(I,J)*B(J)
13        CONTINUE
        ENDIF
        B(I)=SUM/A(I,I)
14    CONTINUE
      RETURN
      END
c========================================================
      subroutine dludcmp(a,vv,n,indx,mxlaglim)
c
      PARAMETER (TINY=1.0E-20)
      real*8 A(mxlaglim,mxlaglim),VV(mxlaglim),aamax,sum,dum
      integer indx(mxlaglim)
c---------------------------------------------------------------
      D=1.D0
      DO 12 I=1,N
        AAMAX=0.D0
        DO 11 J=1,N
          IF (ABS(A(I,J)).GT.AAMAX) AAMAX=ABS(A(I,J))
11      CONTINUE
c       IF (AAMAX.EQ.0.D0) PAUSE 'Singular matrix.'
c        IF (AAMAX.EQ.0.D0) then
c         write(*,*)' i=',i
c         PAUSE 'Singular matrix in dludcmp.'
cc       VV(I)=1./AAMAX
c        VV(I)=tiny
c         endif
c
       VV(I)=1./AAMAX
12    CONTINUE
      DO 19 J=1,N
        IF (J.GT.1) THEN
          DO 14 I=1,J-1
            SUM=A(I,J)
            IF (I.GT.1)THEN
              DO 13 K=1,I-1
                SUM=SUM-A(I,K)*A(K,J)
13            CONTINUE
              A(I,J)=SUM
            ENDIF
14        CONTINUE
        ENDIF
        AAMAX=0.D0
        DO 16 I=J,N
          SUM=A(I,J)
          IF (J.GT.1)THEN
            DO 15 K=1,J-1
              SUM=SUM-A(I,K)*A(K,J)
15          CONTINUE
            A(I,J)=SUM
          ENDIF
          DUM=VV(I)*ABS(SUM)
          IF (DUM.GE.AAMAX) THEN
            IMAX=I
            AAMAX=DUM
          ENDIF
16      CONTINUE
        IF (J.NE.IMAX)THEN
          DO 17 K=1,N
            DUM=A(IMAX,K)
            A(IMAX,K)=A(J,K)
            A(J,K)=DUM
17        CONTINUE
          D=-D
          VV(IMAX)=VV(J)
        ENDIF
        INDX(J)=IMAX
        IF(J.NE.N)THEN
c         IF(A(J,J).EQ.0.D0)A(J,J)=TINY
          IF(A(J,J).EQ.0.D0) then
               A(J,J)=TINY
              endif
          DUM=1./A(J,J)
          DO 18 I=J+1,N
            A(I,J)=A(I,J)*DUM
18        CONTINUE
        ENDIF
19    CONTINUE
c     IF(A(N,N).EQ.0.D0) A(N,N)=TINY
      IF(A(N,N).EQ.0.D0) then
        A(N,N)=TINY
       endif
      RETURN
      END
c******************************************************************
      subroutine fstatcalc(r,u,ndf,numcause,eff)
      essqrd = u/float(ndf)
      eff = ( (r-u)/float(numcause) )  /  essqrd
      return
      end
c******************************************************************
      SUBROUTINE QCKSRT(N,ARR)
      PARAMETER (M=7,NSTACK=50,FM=7875.,FA=211.,FC=1663.
     *    ,FMI=1.2698413E-4)
      DIMENSION ARR(N),ISTACK(NSTACK)
      JSTACK=0
      L=1
      IR=N
      FX=0.
10    IF(IR-L.LT.M)THEN
        DO 13 J=L+1,IR
          A=ARR(J)
          DO 11 I=J-1,1,-1
            IF(ARR(I).LE.A)GO TO 12
            ARR(I+1)=ARR(I)
11        CONTINUE
          I=0
12        ARR(I+1)=A
13      CONTINUE
        IF(JSTACK.EQ.0)RETURN
        IR=ISTACK(JSTACK)
        L=ISTACK(JSTACK-1)
        JSTACK=JSTACK-2
      ELSE
        I=L
        J=IR
        FX=MOD(FX*FA+FC,FM)
        IQ=L+(IR-L+1)*(FX*FMI)
        A=ARR(IQ)
        ARR(IQ)=ARR(L)
20      CONTINUE
21        IF(J.GT.0)THEN
            IF(A.LT.ARR(J))THEN
              J=J-1
              GO TO 21
            ENDIF
          ENDIF
          IF(J.LE.I)THEN
            ARR(I)=A
            GO TO 30
          ENDIF
          ARR(I)=ARR(J)
          I=I+1
22        IF(I.LE.N)THEN
            IF(A.GT.ARR(I))THEN
              I=I+1
              GO TO 22
            ENDIF
          ENDIF
          IF(J.LE.I)THEN
            ARR(J)=A
            I=J
            GO TO 30
          ENDIF
          ARR(J)=ARR(I)
          J=J-1
        GO TO 20
30      JSTACK=JSTACK+2
        IF(JSTACK.GT.NSTACK)PAUSE 'NSTACK must be made larger.'
        IF(IR-I.GE.I-L)THEN
          ISTACK(JSTACK)=IR
          ISTACK(JSTACK-1)=I+1
          IR=I-1
        ELSE
          ISTACK(JSTACK)=I-1
          ISTACK(JSTACK-1)=L
          L=I+1
        ENDIF
      ENDIF
      GO TO 10
      END
      subroutine usual_F_stat(rss,urss,betahatrestrict,
     1  iprint,beta,n,
     1  numvarreadin,numlag,numcause,numsim,fnumsim,numsimestprint,
     1  min_ndf,k,ndf,itaumin,itaumax,numtau,xuse,yuse,betahat,
     1  beta4sims,eps4sims,varlabel,ipow,isim)
c
c
      parameter(mxlaglim=40,mw=4000,maxsim=10000)
c
c  mw         = max # sample observations
c  mxlaglim   = max # regressors in regression model, including intercept
c
      real*8 yuse(-100:mw),xuse(mw,mxlaglim)
c
      real beta(mxlaglim),t(mxlaglim),pval(mxlaglim),
     1       beta4sims(mxlaglim),eps4sims(mw),
     1       betahat(mxlaglim),vcv(mxlaglim,mxlaglim),
     1       betahatrestrict(mxlaglim),btemp(mxlaglim),
     1       etemp(mw)
c
      character*8 varlabel(0:mxlaglim)
c
c
c   for routine (gasdev) that generates unit normals 
c
      common /gassav/ gset,iset
c
c
c   for routine that generates random integers for use in bootstrapping:
c
      COMMON /RANSET/FIMM,IMM,IAA,ICC,IDUM,IY,IDECK(97)
c  Estimate model using OLS:
c
c
      call olsreg(yuse,xuse,btemp,etemp,t,n,k,urss,vcv,ssqd)
c
c     
      if (iprint .eq. 1) then 
      ndf = n - k
      do ik = 1,k
         tcoef = t(ik)
         pval(ik)=  tsig(tcoef,ndf)
      enddo
c
      ymean = 0.
      do i = 1,n
          ymean = ymean + real(yuse(i))
      enddo
      ymean = ymean/float(n)
      vary = 0.
      do i = 1,n
          vary = vary +(real(yuse(i)) - ymean)**2
      enddo
      vary = vary/float(n-1)
      essquared = urss/float(n-k) 
      rsqrdadj = 1. - (essquared/vary)
c      rsqrdadj = 1. - (ssqd/vary)
c
c
      write(6,'(/''Unrestricted Model'')')
      write(6,'(/a8,x,
     1''  coef      t ratio   sig. level'')')   varlabel(0)
       do ik = 1,k
        write(6,'(a8,x,F7.4,3x,f9.3,f11.3)')  varlabel(ik),
     1                 btemp(ik),t(ik),pval(ik)
       enddo
c
c     
          write (6, '(/''s-squared      = '',e20.8)')ssqd
          write (6, '(''adj. R-squared = '',f20.4)')rsqrdadj
c
      endif
c
      call olsreg(yuse,xuse,btemp,etemp,t,n,k-numcause,
     1           rss,vcv,ssqd)
c
c    save fitting errors for use in wild bootstrap simulations
c
      if (isim .eq. 0) then
         do it = 1,n
          eps4sims(it) = etemp(it)
         enddo
         do ik = 1,k
           beta4sims(ik) = btemp(ik)
         enddo
      endif
c
c
      if (iprint .eq. 1) then 
      ndf_restrict = n - k + numcause
      do ik = 1,k - numcause
         tcoef = t(ik)
         pval(ik)=  tsig(tcoef,ndf_restrict)
      enddo
      write(6,'(/''Restricted Model  (numcause variates omitted)'')')
      write(6,'(/a8,x,
     1''  coef      t ratio   sig. level'')')   varlabel(0)
       do ik = 1,k-numcause
        write(6,'(a8,x,F7.4,3x,f9.3,f11.3)')  varlabel(ik),
     1                 btemp(ik),t(ik),pval(ik)
       enddo
c
c     
          write (6, '(/''s-squared      = '',e20.8)')ssqd
          rsqrdadj = 1. - (ssqd/vary)
c
      essquared = rss/float(n-k+numcause) 
      rsqrdadj = 1. - (essquared/vary)
          write (6, '(''adj. R-squared = '',f20.4)')rsqrdadj
      endif
c  
c
c
      return
      end
c   setup code for invoking "sort" routine to sort input vector and
c   compute vfrac(1) ... vfrac(nfrac), the nfrac fractiles
c   specified by frac(1) ... frac(nfrac)
c
c     isrt = 'B'
c     nfrac = 1
c     frac(1) = .95
c     call sort(indx,sortinput,numsim,nfrac,frac,vfrac,isrt,6)
c     crit95(icolumn)  = vfrac(1)
c     numreject = 0
c     do isim = 1,numsim
c         if (fstat_sample(icolumn) .ge. crit95(icolumn))
c    1         numreject = numreject + 1
c     enddo
c     power_reject(icolumn) = float(numreject)/fnumsim
c
c******************************************************************************
      subroutine mccracken(fstat,isim,iprint,n,
     1  numvarreadin,numlag,numcause,numsim,fnumsim,numsimestprint,
     1  min_ndf,k,ndf,itaumin,itaumax,numtau,x,y,varlabel)
c
c this routine computes the MCracken MSE-F test statistic for the
c sample data for npost =  10 periods (index = -5)         
c                 npost =  20 periods (index = -6)
c                 npost =  40 periods (index = -7)
c                 npost = 100 periods (index = -8)
c                 npost =   5 periods (index = -30)
c and stores it in column isim of fstat array (for rows -8 ... -5 and -30).
c
      parameter(mxlaglim=40,mw=4000,maxsim=10000)
c
c  mw         = max # sample observations
c  mxlaglim   = max # regressors in regression model, including intercept
c
      real*8 y(-100:mw),x(mw,mxlaglim),
     1           ypart(-100:mw),xpart(mw,mxlaglim)
c
      real t(mxlaglim),vcv(mxlaglim,mxlaglim),
     1       fstat(-31:mw,0:maxsim),betahatlocal(mxlaglim),
     1       epslocal(mw),fcsterr_restrict(mw),fcsterr_unrestrict(mw)
c
      character*8 varlabel(0:mxlaglim)
      integer npost(5),jfstatrow(5)
c
c
      npost(1) = 10
      npost(2) = 20
      npost(3) = 40
      npost(4) = 100
      npost(5) = 5
      jfstatrow(1) = -5
      jfstatrow(2) = -6
      jfstatrow(3) = -7
      jfstatrow(4) = -8
      jfstatrow(5) = -30
c
      do jpostcase = 1,5
c
c   ndegrees left is the number of degrees of freedom in the first regression,
c   used to make the first (of npost(jpostcase)) postsample forecasts
c
        ndegreesleft = n - k - npost(jpostcase) 
        if (ndegreesleft .ge. 1) then
c
c  initialize postsample sum of squared one-step-ahead forecasting errors 
c  for this postsample length, for both the restricted and unrestricted
c  models:
c
           racken_restrict = 0.
           racken_unrestrict = 0.   
c
c  for the unrestricted model,loop over the possible sample lengths, jsample,
c  estimating model and forecasting one step ahead:
c
           do jsample =  n - npost(jpostcase), n-1
              do irow = 1,jsample
                ypart(irow) = y(irow)
                do icol = 1,k
                  xpart(irow,icol) = x(irow,icol)
                enddo
              enddo
              call olsreg(ypart,xpart,betahatlocal,epslocal,t,jsample,
     1                  k,sse,vcv,ssqd)
              next =  jsample + 1
              fcsterr_unrestrict(next) = y(next)
              do icol = 1,k
                 fcsterr_unrestrict(next) = fcsterr_unrestrict(next) 
     1              - betahatlocal(icol)*x(next,icol)
              enddo
              racken_unrestrict = racken_unrestrict + 
     1             fcsterr_unrestrict(next)*fcsterr_unrestrict(next)    
           enddo 
c
c  for the restricted model,loop over the possible sample lengths, jsample,
c  estimating model and forecasting one step ahead:
c
           do jsample =  n - npost(jpostcase), n-1
              do irow = 1,jsample
                ypart(irow) = y(irow)
                do icol = 1,k - numcause
                  xpart(irow,icol) = x(irow,icol)
                enddo
              enddo
              call olsreg(ypart,xpart,betahatlocal,epslocal,t,jsample,
     1                  k - numcause,sse,vcv,ssqd)
              next =  jsample + 1
              fcsterr_restrict(next) = y(next)
              do icol = 1,k - numcause
                 fcsterr_restrict(next) = fcsterr_restrict(next) 
     1              - betahatlocal(icol)*x(next,icol)
              enddo
              racken_restrict = racken_restrict + 
     1             fcsterr_restrict(next)*fcsterr_restrict(next)    
           enddo 
c
c  compute McCracken MSE-F statistic for this postsample length -- i.e., for this value of
c  npost(jpostcase) -  from McCracken (2007) J. Econometrics 140(2) pp. 719-752 Equation 3, using
c  the squared error loss function.
c 
           fstat(jfstatrow(jpostcase),isim) 
     1        = (racken_restrict - racken_unrestrict)/racken_unrestrict 
c             
           fstat(jfstatrow(jpostcase),isim) 
     1       = float(npost(jpostcase))*fstat(jfstatrow(jpostcase),isim) 
c
c  end if-block over ndegreesleft
c
        endif
c
c end do loop over jpostcase
c
      enddo
c
c
      return
      end        
C***********************************************************************
      subroutine sort(indx,x,n,nfrac,frac,vfrac,isrt,lun)
c*********************************************************
c    D.M. Patterson, and M.J. Hinich
c    Update: 4-11-94
c
c    Single Precision   Error output in unit=lun, ftile='error sort'
c
c    Sorts the pointer array, indx, into ascending order based on reals
c    in array x. Routine uses shaker sort method.
c    Any number of fractiles can be computed from the order statistics
c     using a linear interpolation.
c-----------------------------
c  Definitions of variables
c-----------------------------
c  indx  : integer array that points to locations in array x
c          It is initialized if x is sorted. On output indx(k) is the
c          index of the x(k) sorted in ascending order.
c  x     : array to be sorted by reordering pointers in indx
c  n     : number of elements in x and indx
c  nfrac : number of quantiles to be found and the number of
c           quantiles in the vfrac and frac arrays
c  frac  : input quantiles to be found
c  vfrac : ouput quantiles computed from x
c  isrt  : job control character
c          1) isrt = S : Sort the values in the array x. No fractiles!
c          2) isrt = F : Compute the fractiles. The array x is assumed
c                        to be already sorted!
c          3) isrt = B : Sort the array and compute the fractiles.
c  lun   : unit number for file for error messages
c==================================================
      real x(n)
      real frac(nfrac),vfrac(nfrac)
      integer indx(n)
      character isrt
c     character isrt,op
c**************************************************
c     op='N'
      if(isrt.ne.'S'.and.isrt.ne.'B'.and.isrt.ne.'F') then
c      call fwrite(op,lun)
c      write(8,*) 'Isrt control character in SORT is wrong  ',isrt
       write(lun,*) 'Isrt control character in SORT is wrong  ',isrt
      endif
c---------------------------------------------
c     if(nfrac.le.0. and. isrt.ne.'S') then
c      call fwrite(op,lun)
c      write(8,*) 'Number of fractiles in SORT <= 0: ',nfrac
c      write(lun,*) 'Number of fractiles in SORT <= 0: ',nfrac
c      return
c     endif
c---------------------------------------------
c  Trap n < 1
c     if(n.lt.1) then
c      call fwrite(op,lun)
c      write(8,*) 'n in x(n) < 1',n
c      write(lun,*) 'n in x(n) < 1',n
c      return
c     endif
c---------------------------------------------
c  If the array has one element, set vfrac=x
      if(n.eq.1. and. isrt.ne.'S') then
c      call fwrite(op,lun)
c      write(8,*) 'fractiles set to x since n=1',n
c      write(lun,*) 'fractiles set to x since n=1',n
       do jl=1,nfrac
        vfrac(jl)=x(n)
       enddo
       return
      endif
c---------------------------------------------
      if(isrt.eq.'S'.or.isrt.eq.'B') then
c  Call indexed Heapsort from "Numerical Recipes"
       call indexx(n,x,indx)
      endif
c----------------------------------------------
c  Find the nfrac p% quantiles
      if(isrt.eq.'F'.or.isrt.eq.'B') then
c------------------------------------------------------
c  If frac(j) > 1 then the fractiles are set to the max
c  If frac(j) < 0 then the fractiles are set to the min
c------------------------------------------------------
       do jl=1,nfrac
        if(frac(jl).ge.1.) then
         vfrac(jl)=x(indx(n))
          elseif(frac(jl).le.0.) then
           vfrac(jl)=x(indx(1))
            else
             pn=frac(jl)*real(n+1)
             ji=int(pn)
             g=pn-real(ji)
             ji1=ji+1
             if(ji1.gt.n) ji1=n
             if(ji.le.0) ji=1
             if(ji.gt.n) ji=n
             vfrac(jl)=(1-g)*x(indx(ji))+g*x(indx(ji1))
        endif
       enddo
      endif
c---------------
      return
      end
c
c========================================
c
      subroutine indexx(n,arrin,indx)
c*************************************
      dimension arrin(n),indx(n)
c*************************************
      do 1 j=1,n
  1    indx(j)=j
c----------------
      if(n.eq.1) return
      l=n/2+1
      ir=n
  2   continue
        if(l.gt.1)then
          l=l-1
          indxt=indx(l)
          q=arrin(indxt)
        else
          indxt=indx(ir)
          q=arrin(indxt)
          indx(ir)=indx(1)
          ir=ir-1
          if(ir.eq.1)then
            indx(1)=indxt
            return
          endif
        endif
        i=l
        j=l+l
  3     if(j.le.ir)then
          if(j.lt.ir)then
           if(arrin(indx(j)).lt.arrin(indx(j+1)))j=j+1
          endif
          if(q.lt.arrin(indx(j)))then
            indx(i)=indx(j)
            i=j
            j=j+j
          else
            j=ir+1
          endif
        goto 3
        endif
        indx(i)=indxt
      goto 2
      end


